/* attention, this file was automatically generated by swig and Perl scripts */
#include "drv_onu_std_defs.h"
#include "drv_onu_error.h"
#include "drv_onu_interface.h"
#include "drv_onu_api.h"
#include "drv_onu_cli_core.h"
#include "drv_onu_common_interface.h"
#include "drv_onu_ploam_interface.h"
#include "drv_onu_ploam_api.h"
#include "drv_onu_gtc_interface.h"
#include "drv_onu_gtc_api.h"
#include "drv_onu_gpe_interface.h"
#include "drv_onu_gpe_api.h"
#include "drv_onu_gpe_tables_interface.h"
#include "drv_onu_gpe_tables_api.h"
#include "drv_onu_lan_interface.h"
#include "drv_onu_lan_api.h"
#include "drv_onu_event_interface.h"
#include "drv_onu_event_api.h"

#ifdef INCLUDE_CLI_SUPPORT

extern int onu_cli_check_help(
	const char *p_cmd,
	const char *p_usage,
	const uint32_t bufsize_max,
	char *p_out);

/** \addtogroup ONU_CLI_COMMANDS
   @{
*/

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_init_data param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_init" ONU_CRLF
		"Short Form: gtci" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t dlos_enable" ONU_CRLF
		"- uint32_t dlos_inversion" ONU_CRLF
		"- uint32_t dlos_window_size" ONU_CRLF
		"- uint32_t dlos_trigger_threshold" ONU_CRLF
		"- uint32_t laser_gap" ONU_CRLF
		"- uint32_t laser_offset" ONU_CRLF
		"- uint32_t laser_en_end_ext" ONU_CRLF
		"- uint32_t laser_en_start_ext" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u", &param.dlos.dlos_enable, &param.dlos.dlos_inversion, &param.dlos.dlos_window_size, &param.dlos.dlos_trigger_threshold, &param.laser_gap, &param.laser_offset, &param.laser_en_end_ext, &param.laser_en_start_ext);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_init(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_cfg_set" ONU_CRLF
		"Short Form: gtccs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bip_error_interval" ONU_CRLF
		"- uint32_t sf_threshold" ONU_CRLF
		"- uint32_t sd_threshold" ONU_CRLF
		"- uint32_t onu_response_time" ONU_CRLF
		"- uint32_t serial_number_request_threshold" ONU_CRLF
		"- uint32_t rogue_msg_id" ONU_CRLF
		"- uint32_t rogue_msg_rpt" ONU_CRLF
		"- uint32_t rogue_msg_enable" ONU_CRLF
		"- uint32_t ploam_timeout_1" ONU_CRLF
		"- uint32_t ploam_timeout_2" ONU_CRLF
		"- uint32_t emergency_stop_state" ONU_CRLF
		"- uint8_t password[10]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u %u %u %u %bu[10]", &param.bip_error_interval, &param.sf_threshold, &param.sd_threshold, &param.onu_response_time, &param.serial_number_request_threshold, &param.rogue_msg_id, &param.rogue_msg_rpt, &param.rogue_msg_enable, &param.ploam_timeout_1, &param.ploam_timeout_2, &param.emergency_stop_state, &param.password[0]);
	if (ret != 21) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_cfg_get" ONU_CRLF
		"Short Form: gtccg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t bip_error_interval" ONU_CRLF
		"- uint32_t sf_threshold" ONU_CRLF
		"- uint32_t sd_threshold" ONU_CRLF
		"- uint32_t onu_response_time" ONU_CRLF
		"- uint32_t serial_number_request_threshold" ONU_CRLF
		"- uint32_t rogue_msg_id" ONU_CRLF
		"- uint32_t rogue_msg_rpt" ONU_CRLF
		"- uint32_t rogue_msg_enable" ONU_CRLF
		"- uint32_t ploam_timeout_1" ONU_CRLF
		"- uint32_t ploam_timeout_2" ONU_CRLF
		"- uint32_t emergency_stop_state" ONU_CRLF
		"- uint8_t password[10]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bip_error_interval=%u sf_threshold=%u sd_threshold=%u onu_response_time=%u serial_number_request_threshold=%u rogue_msg_id=%u rogue_msg_rpt=%u rogue_msg_enable=%u ploam_timeout_1=%u ploam_timeout_2=%u emergency_stop_state=%u password=\"%u %u %u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.bip_error_interval, param.sf_threshold, param.sd_threshold, param.onu_response_time, param.serial_number_request_threshold, param.rogue_msg_id, param.rogue_msg_rpt, param.rogue_msg_enable, param.ploam_timeout_1, param.ploam_timeout_2, param.emergency_stop_state, param.password[0], param.password[1], param.password[2], param.password[3], param.password[4], param.password[5], param.password[6], param.password[7], param.password[8], param.password[9]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_counter_threshold_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cnt_value param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_counter_threshold_set" ONU_CRLF
		"Short Form: gtccts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint64_t bip" ONU_CRLF
		"- uint64_t hec_error_corr" ONU_CRLF
		"- uint64_t hec_error_uncorr" ONU_CRLF
		"- uint64_t bwmap_error_corr" ONU_CRLF
		"- uint64_t bwmap_error_uncorr" ONU_CRLF
		"- uint64_t fec_error_corr" ONU_CRLF
		"- uint64_t fec_words_corr" ONU_CRLF
		"- uint64_t fec_words_uncorr" ONU_CRLF
		"- uint64_t fec_words_total" ONU_CRLF
		"- uint64_t tx_gem_frames_total" ONU_CRLF
		"- uint64_t tx_gem_bytes_total" ONU_CRLF
		"- uint64_t tx_gem_idle_frames_total" ONU_CRLF
		"- uint64_t rx_gem_frames_total" ONU_CRLF
		"- uint64_t rx_gem_bytes_total" ONU_CRLF
		"- uint64_t rx_gem_frames_dropped" ONU_CRLF
		"- uint64_t omci_drop" ONU_CRLF
		"- uint64_t drop" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t allocations_total" ONU_CRLF
		"- uint64_t allocations_lost" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu", &param.bip, &param.hec_error_corr, &param.hec_error_uncorr, &param.bwmap_error_corr, &param.bwmap_error_uncorr, &param.fec_error_corr, &param.fec_words_corr, &param.fec_words_uncorr, &param.fec_words_total, &param.tx_gem_frames_total, &param.tx_gem_bytes_total, &param.tx_gem_idle_frames_total, &param.rx_gem_frames_total, &param.rx_gem_bytes_total, &param.rx_gem_frames_dropped, &param.omci_drop, &param.drop, &param.rx_oversized_frames, &param.allocations_total, &param.allocations_lost);
	if (ret != 20) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_counter_threshold_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_counter_threshold_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cnt_value param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_counter_threshold_get" ONU_CRLF
		"Short Form: gtcctg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint64_t bip" ONU_CRLF
		"- uint64_t hec_error_corr" ONU_CRLF
		"- uint64_t hec_error_uncorr" ONU_CRLF
		"- uint64_t bwmap_error_corr" ONU_CRLF
		"- uint64_t bwmap_error_uncorr" ONU_CRLF
		"- uint64_t fec_error_corr" ONU_CRLF
		"- uint64_t fec_words_corr" ONU_CRLF
		"- uint64_t fec_words_uncorr" ONU_CRLF
		"- uint64_t fec_words_total" ONU_CRLF
		"- uint64_t tx_gem_frames_total" ONU_CRLF
		"- uint64_t tx_gem_bytes_total" ONU_CRLF
		"- uint64_t tx_gem_idle_frames_total" ONU_CRLF
		"- uint64_t rx_gem_frames_total" ONU_CRLF
		"- uint64_t rx_gem_bytes_total" ONU_CRLF
		"- uint64_t rx_gem_frames_dropped" ONU_CRLF
		"- uint64_t omci_drop" ONU_CRLF
		"- uint64_t drop" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t allocations_total" ONU_CRLF
		"- uint64_t allocations_lost" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_counter_threshold_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bip=%llu hec_error_corr=%llu hec_error_uncorr=%llu bwmap_error_corr=%llu bwmap_error_uncorr=%llu fec_error_corr=%llu fec_words_corr=%llu fec_words_uncorr=%llu fec_words_total=%llu tx_gem_frames_total=%llu tx_gem_bytes_total=%llu tx_gem_idle_frames_total=%llu rx_gem_frames_total=%llu rx_gem_bytes_total=%llu rx_gem_frames_dropped=%llu omci_drop=%llu drop=%llu rx_oversized_frames=%llu allocations_total=%llu allocations_lost=%llu " ONU_CRLF, (int)fct_ret, param.bip, param.hec_error_corr, param.hec_error_uncorr, param.bwmap_error_corr, param.bwmap_error_uncorr, param.fec_error_corr, param.fec_words_corr, param.fec_words_uncorr, param.fec_words_total, param.tx_gem_frames_total, param.tx_gem_bytes_total, param.tx_gem_idle_frames_total, param.rx_gem_frames_total, param.rx_gem_bytes_total, param.rx_gem_frames_dropped, param.omci_drop, param.drop, param.rx_oversized_frames, param.allocations_total, param.allocations_lost);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_tca_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cnt_value param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_tca_get" ONU_CRLF
		"Short Form: gtctg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint64_t bip" ONU_CRLF
		"- uint64_t hec_error_corr" ONU_CRLF
		"- uint64_t hec_error_uncorr" ONU_CRLF
		"- uint64_t bwmap_error_corr" ONU_CRLF
		"- uint64_t bwmap_error_uncorr" ONU_CRLF
		"- uint64_t fec_error_corr" ONU_CRLF
		"- uint64_t fec_words_corr" ONU_CRLF
		"- uint64_t fec_words_uncorr" ONU_CRLF
		"- uint64_t fec_words_total" ONU_CRLF
		"- uint64_t tx_gem_frames_total" ONU_CRLF
		"- uint64_t tx_gem_bytes_total" ONU_CRLF
		"- uint64_t tx_gem_idle_frames_total" ONU_CRLF
		"- uint64_t rx_gem_frames_total" ONU_CRLF
		"- uint64_t rx_gem_bytes_total" ONU_CRLF
		"- uint64_t rx_gem_frames_dropped" ONU_CRLF
		"- uint64_t omci_drop" ONU_CRLF
		"- uint64_t drop" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t allocations_total" ONU_CRLF
		"- uint64_t allocations_lost" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_tca_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d bip=%llu hec_error_corr=%llu hec_error_uncorr=%llu bwmap_error_corr=%llu bwmap_error_uncorr=%llu fec_error_corr=%llu fec_words_corr=%llu fec_words_uncorr=%llu fec_words_total=%llu tx_gem_frames_total=%llu tx_gem_bytes_total=%llu tx_gem_idle_frames_total=%llu rx_gem_frames_total=%llu rx_gem_bytes_total=%llu rx_gem_frames_dropped=%llu omci_drop=%llu drop=%llu rx_oversized_frames=%llu allocations_total=%llu allocations_lost=%llu " ONU_CRLF, (int)fct_ret, param.bip, param.hec_error_corr, param.hec_error_uncorr, param.bwmap_error_corr, param.bwmap_error_uncorr, param.fec_error_corr, param.fec_words_corr, param.fec_words_uncorr, param.fec_words_total, param.tx_gem_frames_total, param.tx_gem_bytes_total, param.tx_gem_idle_frames_total, param.rx_gem_frames_total, param.rx_gem_bytes_total, param.rx_gem_frames_dropped, param.omci_drop, param.drop, param.rx_oversized_frames, param.allocations_total, param.allocations_lost);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_us_header_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_us_header_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_us_header_cfg_get" ONU_CRLF
		"Short Form: gtcuhcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t us_pattern[32]" ONU_CRLF
		"- uint32_t us_header_len" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_us_header_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d us_pattern=\"0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u\" us_header_len=%u " ONU_CRLF, (int)fct_ret, param.us_pattern[0], param.us_pattern[1], param.us_pattern[2], param.us_pattern[3], param.us_pattern[4], param.us_pattern[5], param.us_pattern[6], param.us_pattern[7], param.us_pattern[8], param.us_pattern[9], param.us_pattern[10], param.us_pattern[11], param.us_pattern[12], param.us_pattern[13], param.us_pattern[14], param.us_pattern[15], param.us_pattern[16], param.us_pattern[17], param.us_pattern[18], param.us_pattern[19], param.us_pattern[20], param.us_pattern[21], param.us_pattern[22], param.us_pattern[23], param.us_pattern[24], param.us_pattern[25], param.us_pattern[26], param.us_pattern[27], param.us_pattern[28], param.us_pattern[29], param.us_pattern[30], param.us_pattern[31], param.us_header_len);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cnt_interval in;
	struct gtc_counters out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_counter_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		"- uint64_t bip" ONU_CRLF
		"- uint64_t hec_error_corr" ONU_CRLF
		"- uint64_t hec_error_uncorr" ONU_CRLF
		"- uint64_t bwmap_error_corr" ONU_CRLF
		"- uint64_t bwmap_error_uncorr" ONU_CRLF
		"- uint64_t fec_error_corr" ONU_CRLF
		"- uint64_t fec_words_corr" ONU_CRLF
		"- uint64_t fec_words_uncorr" ONU_CRLF
		"- uint64_t fec_words_total" ONU_CRLF
		"- uint64_t tx_gem_frames_total" ONU_CRLF
		"- uint64_t tx_gem_bytes_total" ONU_CRLF
		"- uint64_t tx_gem_idle_frames_total" ONU_CRLF
		"- uint64_t rx_gem_frames_total" ONU_CRLF
		"- uint64_t rx_gem_bytes_total" ONU_CRLF
		"- uint64_t rx_gem_frames_dropped" ONU_CRLF
		"- uint64_t omci_drop" ONU_CRLF
		"- uint64_t drop" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t allocations_total" ONU_CRLF
		"- uint64_t allocations_lost" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.reset_mask, &in.curr);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d reset_mask=%u curr=%u bip=%llu hec_error_corr=%llu hec_error_uncorr=%llu bwmap_error_corr=%llu bwmap_error_uncorr=%llu fec_error_corr=%llu fec_words_corr=%llu fec_words_uncorr=%llu fec_words_total=%llu tx_gem_frames_total=%llu tx_gem_bytes_total=%llu tx_gem_idle_frames_total=%llu rx_gem_frames_total=%llu rx_gem_bytes_total=%llu rx_gem_frames_dropped=%llu omci_drop=%llu drop=%llu rx_oversized_frames=%llu allocations_total=%llu allocations_lost=%llu " ONU_CRLF, (int)fct_ret, out.interval.reset_mask, out.interval.curr, out.val.bip, out.val.hec_error_corr, out.val.hec_error_uncorr, out.val.bwmap_error_corr, out.val.bwmap_error_uncorr, out.val.fec_error_corr, out.val.fec_words_corr, out.val.fec_words_uncorr, out.val.fec_words_total, out.val.tx_gem_frames_total, out.val.tx_gem_bytes_total, out.val.tx_gem_idle_frames_total, out.val.rx_gem_frames_total, out.val.rx_gem_bytes_total, out.val.rx_gem_frames_dropped, out.val.omci_drop, out.val.drop, out.val.rx_oversized_frames, out.val.allocations_total, out.val.allocations_lost);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_cnt_interval param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_counter_reset" ONU_CRLF
		"Short Form: gtccr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.reset_mask, &param.curr);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_status_get" ONU_CRLF
		"Short Form: gtcsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t ds_fec_enable" ONU_CRLF
		"- uint32_t us_fec_enable" ONU_CRLF
		"- uint32_t ds_ploam_waiting" ONU_CRLF
		"- uint32_t ds_ploam_overflow" ONU_CRLF
		"- enum gtc_receive_state ds_state" ONU_CRLF
		"   GPON_STATE_HUNT = 0" "\n"
		"   GPON_STATE_PRESYNC = 1" "\n"
		"   GPON_STATE_SYNC = 3" "\n"
		"- enum gtc_receive_sf_state ds_sf_state" ONU_CRLF
		"   GPON_SF_STATE_HUNT = 0" "\n"
		"   GPON_SF_STATE_PRESYNC = 1" "\n"
		"   GPON_SF_STATE_SYNC = 3" "\n"
		"- uint32_t ds_physical_equipment_error" ONU_CRLF
		"- uint32_t onu_id" ONU_CRLF
		"- uint32_t gtc_ds_delay" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d ds_fec_enable=%u us_fec_enable=%u ds_ploam_waiting=%u ds_ploam_overflow=%u ds_state=%u ds_sf_state=%u ds_physical_equipment_error=%u onu_id=%u gtc_ds_delay=%u " ONU_CRLF, (int)fct_ret, param.ds_fec_enable, param.us_fec_enable, param.ds_ploam_waiting, param.ds_ploam_overflow, param.ds_state, param.ds_sf_state, param.ds_physical_equipment_error, param.onu_id, param.gtc_ds_delay);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_alarm_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_alarm param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_alarm_get" ONU_CRLF
		"Short Form: gtcag" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t alarm" ONU_CRLF
		"- uint32_t sig_fail" ONU_CRLF
		"- uint32_t sig_degrade" ONU_CRLF
		"- uint32_t loss_of_signal" ONU_CRLF
		"- uint32_t loss_of_gem_frame" ONU_CRLF
		"- uint32_t gem_frame_starvation" ONU_CRLF
		"- uint32_t loss_of_gtc_frame" ONU_CRLF
		"- uint32_t loss_of_gtc_superframe" ONU_CRLF
		"- uint32_t ploam_rx_error" ONU_CRLF
		"- uint32_t ploam_rx_buffer_error" ONU_CRLF
		"- uint32_t ploam_tx_buffer_error" ONU_CRLF
		"- uint32_t counter_overflow" ONU_CRLF
		"- uint32_t plen_warning" ONU_CRLF
		"- uint32_t plen_error" ONU_CRLF
		"- uint32_t physical_equipment_error" ONU_CRLF
		"- uint32_t loss_of_allocation" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_alarm_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d alarm=%u sig_fail=%u sig_degrade=%u loss_of_signal=%u loss_of_gem_frame=%u gem_frame_starvation=%u loss_of_gtc_frame=%u loss_of_gtc_superframe=%u ploam_rx_error=%u ploam_rx_buffer_error=%u ploam_tx_buffer_error=%u counter_overflow=%u plen_warning=%u plen_error=%u physical_equipment_error=%u loss_of_allocation=%u " ONU_CRLF, (int)fct_ret, param.alarm, param.sig_fail, param.sig_degrade, param.loss_of_signal, param.loss_of_gem_frame, param.gem_frame_starvation, param.loss_of_gtc_frame, param.loss_of_gtc_superframe, param.ploam_rx_error, param.ploam_rx_buffer_error, param.ploam_tx_buffer_error, param.counter_overflow, param.plen_warning, param.plen_error, param.physical_equipment_error, param.loss_of_allocation);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_ranging_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_ranging_val param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_ranging_get" ONU_CRLF
		"Short Form: gtcrg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t ranged_delay_enable" ONU_CRLF
		"- uint32_t random_delay" ONU_CRLF
		"- uint32_t preassigned_delay" ONU_CRLF
		"- uint32_t ranged_delay" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_ranging_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d ranged_delay_enable=%u random_delay=%u preassigned_delay=%u ranged_delay=%u " ONU_CRLF, (int)fct_ret, param.ranged_delay_enable, param.random_delay, param.preassigned_delay, param.ranged_delay);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_dying_gasp_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_dgasp_msg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_dying_gasp_cfg_set" ONU_CRLF
		"Short Form: gtcdgcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t dying_gasp_msg[12]" ONU_CRLF
		"- uint32_t dying_gasp_auto" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu[12] %u", &param.dying_gasp_msg[0], &param.dying_gasp_auto);
	if (ret != 13) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_dying_gasp_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_dying_gasp_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_dgasp_msg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_dying_gasp_cfg_get" ONU_CRLF
		"Short Form: gtcdgcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t dying_gasp_msg[12]" ONU_CRLF
		"- uint32_t dying_gasp_auto" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_dying_gasp_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d dying_gasp_msg=\"%u %u %u %u %u %u %u %u %u %u %u %u\" dying_gasp_auto=%u " ONU_CRLF, (int)fct_ret, param.dying_gasp_msg[0], param.dying_gasp_msg[1], param.dying_gasp_msg[2], param.dying_gasp_msg[3], param.dying_gasp_msg[4], param.dying_gasp_msg[5], param.dying_gasp_msg[6], param.dying_gasp_msg[7], param.dying_gasp_msg[8], param.dying_gasp_msg[9], param.dying_gasp_msg[10], param.dying_gasp_msg[11], param.dying_gasp_auto);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_no_message_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_no_msg_msg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_no_message_cfg_set" ONU_CRLF
		"Short Form: gtcnmcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t no_msg_is_scrambled" ONU_CRLF
		"- uint8_t no_msg[12]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %bu[12]", &param.no_msg_is_scrambled, &param.no_msg[0]);
	if (ret != 13) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_no_message_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_no_message_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_no_msg_msg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_no_message_cfg_get" ONU_CRLF
		"Short Form: gtcnmcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t no_msg_is_scrambled" ONU_CRLF
		"- uint8_t no_msg[12]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_no_message_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d no_msg_is_scrambled=%u no_msg=\"%u %u %u %u %u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.no_msg_is_scrambled, param.no_msg[0], param.no_msg[1], param.no_msg[2], param.no_msg[3], param.no_msg[4], param.no_msg[5], param.no_msg[6], param.no_msg[7], param.no_msg[8], param.no_msg[9], param.no_msg[10], param.no_msg[11]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_power_saving_mode_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_op_mode param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_power_saving_mode_set" ONU_CRLF
		"Short Form: gtcpsms" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum gtc_power_saving_mode gpon_op_mode" ONU_CRLF
		"   GPON_POWER_SAVING_MODE_OFF = 0" "\n"
		"   GPON_POWER_SAVING_DEEP_SLEEP = 1" "\n"
		"   GPON_POWER_SAVING_FAST_SLEEP = 2" "\n"
		"   GPON_POWER_SAVING_DOZING = 3" "\n"
		"   GPON_POWER_SAVING_POWER_SHEDDING = 4" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.gpon_op_mode);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_power_saving_mode_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_power_saving_mode_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_op_mode param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_power_saving_mode_get" ONU_CRLF
		"Short Form: gtcpsmg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- enum gtc_power_saving_mode gpon_op_mode" ONU_CRLF
		"   GPON_POWER_SAVING_MODE_OFF = 0" "\n"
		"   GPON_POWER_SAVING_DEEP_SLEEP = 1" "\n"
		"   GPON_POWER_SAVING_FAST_SLEEP = 2" "\n"
		"   GPON_POWER_SAVING_DOZING = 3" "\n"
		"   GPON_POWER_SAVING_POWER_SHEDDING = 4" "\n"
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_power_saving_mode_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d gpon_op_mode=%u " ONU_CRLF, (int)fct_ret, param.gpon_op_mode);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_ploam_send(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_ploamu param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_ploam_send" ONU_CRLF
		"Short Form: gtcps" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t onu_id" ONU_CRLF
		"- uint8_t msg_id" ONU_CRLF
		"- uint8_t data[10]" ONU_CRLF
		"- uint8_t repeat" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %bu %bu[10] %bu", &param.onu_id, &param.msg_id, &param.data[0], &param.repeat);
	if (ret != 13) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_ploam_send(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_ploam_receive(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_ploamd param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_ploam_receive" ONU_CRLF
		"Short Form: gtcpr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t onu_id" ONU_CRLF
		"- uint8_t msg_id" ONU_CRLF
		"- uint8_t data[10]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_ploam_receive(p_dev, &param);
	return sprintf(p_out, "errorcode=%d onu_id=%u msg_id=%u data=\"%u %u %u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.onu_id, param.msg_id, param.data[0], param.data[1], param.data[2], param.data[3], param.data[4], param.data[5], param.data[6], param.data[7], param.data[8], param.data[9]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_serial_number_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_serial_num param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_serial_number_set" ONU_CRLF
		"Short Form: gtcsns" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t serial_number[8]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu[8]", &param.serial_number[0]);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_serial_number_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_serial_number_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_serial_num param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_serial_number_get" ONU_CRLF
		"Short Form: gtcsng" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t serial_number[8]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_serial_number_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d serial_number=\"%u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.serial_number[0], param.serial_number[1], param.serial_number[2], param.serial_number[3], param.serial_number[4], param.serial_number[5], param.serial_number[6], param.serial_number[7]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_password_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_password param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_password_set" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t password[10]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu[10]", &param.password[0]);
	if (ret != 10) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_password_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_password_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_password param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_password_get" ONU_CRLF
		"Short Form: gtcpg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t password[10]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_password_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d password=\"%u %u %u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.password[0], param.password[1], param.password[2], param.password[3], param.password[4], param.password[5], param.password[6], param.password[7], param.password[8], param.password[9]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_forced_alloc_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_forced_alloc param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_forced_alloc_set" ONU_CRLF
		"Short Form: gtcfas" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t start_time" ONU_CRLF
		"- uint32_t stop_time" ONU_CRLF
		"- uint32_t alloc_id" ONU_CRLF
		"- uint32_t flags" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u", &param.enable, &param.start_time, &param.stop_time, &param.alloc_id, &param.flags);
	if (ret != 5) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_forced_alloc_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_forced_alloc_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_forced_alloc param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_forced_alloc_get" ONU_CRLF
		"Short Form: gtcfag" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t start_time" ONU_CRLF
		"- uint32_t stop_time" ONU_CRLF
		"- uint32_t alloc_id" ONU_CRLF
		"- uint32_t flags" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_forced_alloc_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d enable=%u start_time=%u stop_time=%u alloc_id=%u flags=%u " ONU_CRLF, (int)fct_ret, param.enable, param.start_time, param.stop_time, param.alloc_id, param.flags);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_bwmt_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_bwmt_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_bwmt_cfg_set" ONU_CRLF
		"Short Form: gtcbcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t trace_enable" ONU_CRLF
		"- uint32_t overhead_size_enable" ONU_CRLF
		"- uint32_t data_size_enable" ONU_CRLF
		"- uint32_t parity_size_enable" ONU_CRLF
		"- uint32_t start_time_enable" ONU_CRLF
		"- uint32_t stop_time_enable" ONU_CRLF
		"- uint32_t start_stop_enable" ONU_CRLF
		"- uint32_t plou_enable" ONU_CRLF
		"- uint32_t overlap_enable" ONU_CRLF
		"- uint32_t no_gem_enable" ONU_CRLF
		"- uint32_t sw_trigger" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u %u %u %u", &param.trace_enable, &param.overhead_size_enable, &param.data_size_enable, &param.parity_size_enable, &param.start_time_enable, &param.stop_time_enable, &param.start_stop_enable, &param.plou_enable, &param.overlap_enable, &param.no_gem_enable, &param.sw_trigger);
	if (ret != 11) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_bwmt_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_bwmt_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_bwmt_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_bwmt_cfg_get" ONU_CRLF
		"Short Form: gtcbcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t trace_enable" ONU_CRLF
		"- uint32_t overhead_size_enable" ONU_CRLF
		"- uint32_t data_size_enable" ONU_CRLF
		"- uint32_t parity_size_enable" ONU_CRLF
		"- uint32_t start_time_enable" ONU_CRLF
		"- uint32_t stop_time_enable" ONU_CRLF
		"- uint32_t start_stop_enable" ONU_CRLF
		"- uint32_t plou_enable" ONU_CRLF
		"- uint32_t overlap_enable" ONU_CRLF
		"- uint32_t no_gem_enable" ONU_CRLF
		"- uint32_t sw_trigger" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_bwmt_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d trace_enable=%u overhead_size_enable=%u data_size_enable=%u parity_size_enable=%u start_time_enable=%u stop_time_enable=%u start_stop_enable=%u plou_enable=%u overlap_enable=%u no_gem_enable=%u sw_trigger=%u " ONU_CRLF, (int)fct_ret, param.trace_enable, param.overhead_size_enable, param.data_size_enable, param.parity_size_enable, param.start_time_enable, param.stop_time_enable, param.start_stop_enable, param.plou_enable, param.overlap_enable, param.no_gem_enable, param.sw_trigger);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_bwmt_next(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_bwmt_next_data param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_bwmt_next" ONU_CRLF
		"Short Form: gtcbn" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t trace_start" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.trace_start);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gtc_bwmt_next(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_bwmt_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_bwmt_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_bwmt_status_get" ONU_CRLF
		"Short Form: gtcbsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t overhead_size_enable" ONU_CRLF
		"- uint32_t data_size_enable" ONU_CRLF
		"- uint32_t parity_size_enable" ONU_CRLF
		"- uint32_t start_time_enable" ONU_CRLF
		"- uint32_t stop_time_enable" ONU_CRLF
		"- uint32_t start_stop_enable" ONU_CRLF
		"- uint32_t plou_enable" ONU_CRLF
		"- uint32_t overlap_enable" ONU_CRLF
		"- uint32_t no_gem_enable" ONU_CRLF
		"- uint32_t sw_trigger" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_bwmt_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d overhead_size_enable=%u data_size_enable=%u parity_size_enable=%u start_time_enable=%u stop_time_enable=%u start_stop_enable=%u plou_enable=%u overlap_enable=%u no_gem_enable=%u sw_trigger=%u " ONU_CRLF, (int)fct_ret, param.overhead_size_enable, param.data_size_enable, param.parity_size_enable, param.start_time_enable, param.stop_time_enable, param.start_stop_enable, param.plou_enable, param.overlap_enable, param.no_gem_enable, param.sw_trigger);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_last_change_time_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_last_change_time param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_last_change_time_get" ONU_CRLF
		"Short Form: gtclctg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t time" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_last_change_time_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d time=%u " ONU_CRLF, (int)fct_ret, param.time);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gtc_pon_id_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gtc_pon_id param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gtc_pon_id_get" ONU_CRLF
		"Short Form: gtcpig" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t reach_extender_present" ONU_CRLF
		"- uint8_t odn_class" ONU_CRLF
		"- uint16_t olt_tx_power" ONU_CRLF
		"- uint8_t pon_id[7]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gtc_pon_id_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d reach_extender_present=%u odn_class=%u olt_tx_power=%hu pon_id=\"%u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.reach_extender_present, param.odn_class, param.olt_tx_power, param.pon_id[0], param.pon_id[1], param.pon_id[2], param.pon_id[3], param.pon_id[4], param.pon_id[5], param.pon_id[6]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_init_data param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_init" ONU_CRLF
		"Short Form: gpei" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- char fw_name[32]" ONU_CRLF
		"- uint32_t fsqm" ONU_CRLF
		"- uint32_t iqm" ONU_CRLF
		"- uint32_t tmu" ONU_CRLF
		"- uint32_t ictrll[4]" ONU_CRLF
		"- uint32_t octrll[4]" ONU_CRLF
		"- uint32_t ictrlg" ONU_CRLF
		"- uint32_t octrlg" ONU_CRLF
		"- enum gpe_arb_mode arb_mode" ONU_CRLF
		"   ARB_MODE_NA = -1" "\n"
		"   ARB_MODE_DEFAULT = 0" "\n"
		"   ARB_MODE_GIG2_5 = 1" "\n"
		"- uint32_t num_pe" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%s%u %u %u %u[4] %u[4] %u %u %u %u", &param.fw_name, &param.ll_mod_sel.fsqm, &param.ll_mod_sel.iqm, &param.ll_mod_sel.tmu, &param.ll_mod_sel.ictrll[0], &param.ll_mod_sel.octrll[0], &param.ll_mod_sel.ictrlg, &param.ll_mod_sel.octrlg, &param.arb_mode, &param.num_pe);
	if (ret != 16) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_init(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_debug_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_init_data param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_debug_init" ONU_CRLF
		"Short Form: gpedi" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- char fw_name[32]" ONU_CRLF
		"- uint32_t fsqm" ONU_CRLF
		"- uint32_t iqm" ONU_CRLF
		"- uint32_t tmu" ONU_CRLF
		"- uint32_t ictrll[4]" ONU_CRLF
		"- uint32_t octrll[4]" ONU_CRLF
		"- uint32_t ictrlg" ONU_CRLF
		"- uint32_t octrlg" ONU_CRLF
		"- enum gpe_arb_mode arb_mode" ONU_CRLF
		"   ARB_MODE_NA = -1" "\n"
		"   ARB_MODE_DEFAULT = 0" "\n"
		"   ARB_MODE_GIG2_5 = 1" "\n"
		"- uint32_t num_pe" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%s%u %u %u %u[4] %u[4] %u %u %u %u", &param.fw_name, &param.ll_mod_sel.fsqm, &param.ll_mod_sel.iqm, &param.ll_mod_sel.tmu, &param.ll_mod_sel.ictrll[0], &param.ll_mod_sel.octrll[0], &param.ll_mod_sel.ictrlg, &param.ll_mod_sel.octrlg, &param.arb_mode, &param.num_pe);
	if (ret != 16) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_debug_init(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_low_level_modules_enable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ll_mod_sel param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_low_level_modules_enable" ONU_CRLF
		"Short Form: gpellme" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t fsqm" ONU_CRLF
		"- uint32_t iqm" ONU_CRLF
		"- uint32_t tmu" ONU_CRLF
		"- uint32_t ictrll[4]" ONU_CRLF
		"- uint32_t octrll[4]" ONU_CRLF
		"- uint32_t ictrlg" ONU_CRLF
		"- uint32_t octrlg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u[4] %u[4] %u %u", &param.fsqm, &param.iqm, &param.tmu, &param.ictrll[0], &param.octrll[0], &param.ictrlg, &param.octrlg);
	if (ret != 13) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_low_level_modules_enable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_cfg_set" ONU_CRLF
		"Short Form: gpecs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_blk_len" ONU_CRLF
		"- uint32_t gem_payload_size_max" ONU_CRLF
		"- uint32_t pdu_size_max_eth" ONU_CRLF
		"- uint32_t pdu_size_max_omci" ONU_CRLF
		"- uint32_t pdu_size_max_ip" ONU_CRLF
		"- uint32_t pdu_size_max_mpls" ONU_CRLF
		"- uint32_t dbru_dbg_mode" ONU_CRLF
		"- uint32_t aging_time" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u", &param.gem_blk_len, &param.gem_payload_size_max, &param.pdu_size_max_eth, &param.pdu_size_max_omci, &param.pdu_size_max_ip, &param.pdu_size_max_mpls, &param.dbru_dbg_mode, &param.aging_time);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_cfg_get" ONU_CRLF
		"Short Form: gpecg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gem_blk_len" ONU_CRLF
		"- uint32_t gem_payload_size_max" ONU_CRLF
		"- uint32_t pdu_size_max_eth" ONU_CRLF
		"- uint32_t pdu_size_max_omci" ONU_CRLF
		"- uint32_t pdu_size_max_ip" ONU_CRLF
		"- uint32_t pdu_size_max_mpls" ONU_CRLF
		"- uint32_t dbru_dbg_mode" ONU_CRLF
		"- uint32_t aging_time" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d gem_blk_len=%u gem_payload_size_max=%u pdu_size_max_eth=%u pdu_size_max_omci=%u pdu_size_max_ip=%u pdu_size_max_mpls=%u dbru_dbg_mode=%u aging_time=%u " ONU_CRLF, (int)fct_ret, param.gem_blk_len, param.gem_payload_size_max, param.pdu_size_max_eth, param.pdu_size_max_omci, param.pdu_size_max_ip, param.pdu_size_max_mpls, param.dbru_dbg_mode, param.aging_time);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_status_get" ONU_CRLF
		"Short Form: gpesg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t dbru_mode" ONU_CRLF
		"- uint32_t ssb_size" ONU_CRLF
		"- uint32_t num_pe" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d dbru_mode=%u ssb_size=%u num_pe=%u " ONU_CRLF, (int)fct_ret, param.dbru_mode, param.ssb_size, param.num_pe);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_port_add(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_gem_port in;
	struct gpe_gem_port out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_port_add" ONU_CRLF
		"Short Form: gpegpa" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_id" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t gem_port_is_omci" ONU_CRLF
		"- uint32_t gem_port_is_mc" ONU_CRLF
		"- enum gpe_direction data_direction" ONU_CRLF
		"   GPE_DIRECTION_UPSTREAM = 1" "\n"
		"   GPE_DIRECTION_DOWNSTREAM = 2" "\n"
		"   GPE_DIRECTION_BIDIRECTIONAL = 3" "\n"
		"- uint32_t gem_port_enable" ONU_CRLF
		"- uint32_t encryption_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gem_port_id" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t gem_port_is_omci" ONU_CRLF
		"- uint32_t gem_port_is_mc" ONU_CRLF
		"- enum gpe_direction data_direction" ONU_CRLF
		"   GPE_DIRECTION_UPSTREAM = 1" "\n"
		"   GPE_DIRECTION_DOWNSTREAM = 2" "\n"
		"   GPE_DIRECTION_BIDIRECTIONAL = 3" "\n"
		"- uint32_t gem_port_enable" ONU_CRLF
		"- uint32_t encryption_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u", &in.gem_port_id, &in.gem_port_index, &in.gem_port_is_omci, &in.gem_port_is_mc, &in.data_direction, &in.gem_port_enable, &in.encryption_enable);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_port_add(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d gem_port_id=%u gem_port_index=%u gem_port_is_omci=%u gem_port_is_mc=%u data_direction=%u gem_port_enable=%u encryption_enable=%u " ONU_CRLF, (int)fct_ret, out.gem_port_id, out.gem_port_index, out.gem_port_is_omci, out.gem_port_is_mc, out.data_direction, out.gem_port_enable, out.encryption_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_port_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gem_port_id param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_port_delete" ONU_CRLF
		"Short Form: gpegpd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.val);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_port_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_port_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gem_port_id in;
	struct gpe_gem_port out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_port_get" ONU_CRLF
		"Short Form: gpegpg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gem_port_id" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t gem_port_is_omci" ONU_CRLF
		"- uint32_t gem_port_is_mc" ONU_CRLF
		"- enum gpe_direction data_direction" ONU_CRLF
		"   GPE_DIRECTION_UPSTREAM = 1" "\n"
		"   GPE_DIRECTION_DOWNSTREAM = 2" "\n"
		"   GPE_DIRECTION_BIDIRECTIONAL = 3" "\n"
		"- uint32_t gem_port_enable" ONU_CRLF
		"- uint32_t encryption_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.val);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_port_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d gem_port_id=%u gem_port_index=%u gem_port_is_omci=%u gem_port_is_mc=%u data_direction=%u gem_port_enable=%u encryption_enable=%u " ONU_CRLF, (int)fct_ret, out.gem_port_id, out.gem_port_index, out.gem_port_is_omci, out.gem_port_is_mc, out.data_direction, out.gem_port_enable, out.encryption_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_port_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_gem_port in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_port_set" ONU_CRLF
		"Short Form: gpegps" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_id" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t gem_port_is_omci" ONU_CRLF
		"- uint32_t gem_port_is_mc" ONU_CRLF
		"- enum gpe_direction data_direction" ONU_CRLF
		"   GPE_DIRECTION_UPSTREAM = 1" "\n"
		"   GPE_DIRECTION_DOWNSTREAM = 2" "\n"
		"   GPE_DIRECTION_BIDIRECTIONAL = 3" "\n"
		"- uint32_t gem_port_enable" ONU_CRLF
		"- uint32_t encryption_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u", &in.gem_port_id, &in.gem_port_index, &in.gem_port_is_omci, &in.gem_port_is_mc, &in.data_direction, &in.gem_port_enable, &in.encryption_enable);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_port_set(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tcont_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tcont_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tcont_create" ONU_CRLF
		"Short Form: gpetc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		"- uint32_t policy" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.epn, &param.policy);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tcont_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tcont_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tcont param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tcont_set" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tcont_idx" ONU_CRLF
		"- uint32_t alloc_id" ONU_CRLF
		"- uint32_t reg_egress_port" ONU_CRLF
		"- uint32_t pre_egress_port" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u", &param.tcont_idx, &param.alloc_id, &param.reg_egress_port, &param.pre_egress_port);
	if (ret != 4) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tcont_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tcont_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct tcont_index in;
	struct gpe_tcont out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tcont_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tcont_idx" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tcont_idx" ONU_CRLF
		"- uint32_t alloc_id" ONU_CRLF
		"- uint32_t reg_egress_port" ONU_CRLF
		"- uint32_t pre_egress_port" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.tcont_idx);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tcont_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d tcont_idx=%u alloc_id=%u reg_egress_port=%u pre_egress_port=%u " ONU_CRLF, (int)fct_ret, out.tcont_idx, out.alloc_id, out.reg_egress_port, out.pre_egress_port);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tcont_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct tcont_index param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tcont_delete" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tcont_idx" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.tcont_idx);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tcont_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_eport_create param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_create" ONU_CRLF
		"Short Form: gpeepc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t is_uni" ONU_CRLF
		"- uint32_t regular_epn" ONU_CRLF
		"- uint32_t regular_sbid" ONU_CRLF
		"- uint32_t preempting_epn" ONU_CRLF
		"- uint32_t preempting_sbid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u", &param.index, &param.is_uni, &param.regular_epn, &param.regular_sbid, &param.preempting_epn, &param.preempting_sbid);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_epn in;
	struct gpe_eport_create out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_get" ONU_CRLF
		"Short Form: gpeepg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t is_uni" ONU_CRLF
		"- uint32_t regular_epn" ONU_CRLF
		"- uint32_t regular_sbid" ONU_CRLF
		"- uint32_t preempting_epn" ONU_CRLF
		"- uint32_t preempting_sbid" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.epn);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u is_uni=%u regular_epn=%u regular_sbid=%u preempting_epn=%u preempting_sbid=%u " ONU_CRLF, (int)fct_ret, out.index, out.is_uni, out.regular_epn, out.regular_sbid, out.preempting_epn, out.preempting_sbid);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_port_index_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_egress_port in;
	struct gpe_eport_create out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_port_index_get" ONU_CRLF
		"Short Form: gpepig" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t is_uni" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t is_uni" ONU_CRLF
		"- uint32_t regular_epn" ONU_CRLF
		"- uint32_t regular_sbid" ONU_CRLF
		"- uint32_t preempting_epn" ONU_CRLF
		"- uint32_t preempting_sbid" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.index, &in.is_uni);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_port_index_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u is_uni=%u regular_epn=%u regular_sbid=%u preempting_epn=%u preempting_sbid=%u " ONU_CRLF, (int)fct_ret, out.index, out.is_uni, out.regular_epn, out.regular_sbid, out.preempting_epn, out.preempting_sbid);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_egress_port param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_delete" ONU_CRLF
		"Short Form: gpeepd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t is_uni" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.index, &param.is_uni);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_egress_port_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_cfg_set" ONU_CRLF
		"Short Form: gpeepcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t egress_port_threshold_max" ONU_CRLF
		"- uint32_t egress_port_threshold_green" ONU_CRLF
		"- uint32_t egress_port_threshold_yellow" ONU_CRLF
		"- uint32_t egress_port_threshold_red" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u", &param.epn, &param.enable, &param.egress_port_threshold_max, &param.egress_port_threshold_green, &param.egress_port_threshold_yellow, &param.egress_port_threshold_red);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_epn in;
	struct gpe_egress_port_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_cfg_get" ONU_CRLF
		"Short Form: gpeepcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t egress_port_threshold_max" ONU_CRLF
		"- uint32_t egress_port_threshold_green" ONU_CRLF
		"- uint32_t egress_port_threshold_yellow" ONU_CRLF
		"- uint32_t egress_port_threshold_red" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.epn);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d epn=%u enable=%u egress_port_threshold_max=%u egress_port_threshold_green=%u egress_port_threshold_yellow=%u egress_port_threshold_red=%u " ONU_CRLF, (int)fct_ret, out.epn, out.enable, out.egress_port_threshold_max, out.egress_port_threshold_green, out.egress_port_threshold_yellow, out.egress_port_threshold_red);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_epn in;
	struct gpe_egress_port_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_status_get" ONU_CRLF
		"Short Form: gpeepsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		"- uint32_t egress_port_occupancy_max" ONU_CRLF
		"- uint32_t egress_port_occupancy_green" ONU_CRLF
		"- uint32_t egress_port_occupancy_yellow" ONU_CRLF
		"- uint32_t egress_port_occupancy_red" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.epn);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_status_get(p_dev, &in, &param);
	return sprintf(p_out, "errorcode=%d epn=%u egress_port_occupancy_max=%u egress_port_occupancy_green=%u egress_port_occupancy_yellow=%u egress_port_occupancy_red=%u " ONU_CRLF, (int)fct_ret, param.epn, param.egress_port_occupancy_max, param.egress_port_occupancy_green, param.egress_port_occupancy_yellow, param.egress_port_occupancy_red);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_backpressure_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_backpressure_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_backpressure_cfg_set" ONU_CRLF
		"Short Form: gpebcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t free_segment_threshold[5]" ONU_CRLF
		"- uint32_t lan_queue_backpressure_high[4]" ONU_CRLF
		"- uint32_t lan_queue_backpressure_low[4]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u[5] %u[4] %u[4]", &param.free_segment_threshold[0], &param.lan_queue_backpressure_high[0], &param.lan_queue_backpressure_low[0]);
	if (ret != 13) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_backpressure_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_backpressure_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_backpressure_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_backpressure_cfg_get" ONU_CRLF
		"Short Form: gpebcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t free_segment_threshold[5]" ONU_CRLF
		"- uint32_t lan_queue_backpressure_high[4]" ONU_CRLF
		"- uint32_t lan_queue_backpressure_low[4]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_backpressure_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d free_segment_threshold=\"%u %u %u %u %u\" lan_queue_backpressure_high=\"%u %u %u %u\" lan_queue_backpressure_low=\"%u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.free_segment_threshold[0], param.free_segment_threshold[1], param.free_segment_threshold[2], param.free_segment_threshold[3], param.free_segment_threshold[4], param.lan_queue_backpressure_high[0], param.lan_queue_backpressure_high[1], param.lan_queue_backpressure_high[2], param.lan_queue_backpressure_high[3], param.lan_queue_backpressure_low[0], param.lan_queue_backpressure_low[1], param.lan_queue_backpressure_low[2], param.lan_queue_backpressure_low[3]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ingress_queue_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqueue_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ingress_queue_cfg_set" ONU_CRLF
		"Short Form: gpeiqcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t qe" ONU_CRLF
		"- uint32_t qdth" ONU_CRLF
		"- uint32_t qrth" ONU_CRLF
		"- uint32_t qb" ONU_CRLF
		"- uint32_t qbth" ONU_CRLF
		"- uint32_t qbtl" ONU_CRLF
		"- uint32_t tmask" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u", &param.index, &param.qe, &param.qdth, &param.qrth, &param.qb, &param.qbth, &param.qbtl, &param.tmask);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ingress_queue_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ingress_queue_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqueue in;
	struct gpe_iqueue_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ingress_queue_cfg_get" ONU_CRLF
		"Short Form: gpeiqcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t qe" ONU_CRLF
		"- uint32_t qdth" ONU_CRLF
		"- uint32_t qrth" ONU_CRLF
		"- uint32_t qb" ONU_CRLF
		"- uint32_t qbth" ONU_CRLF
		"- uint32_t qbtl" ONU_CRLF
		"- uint32_t tmask" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ingress_queue_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u qe=%u qdth=%u qrth=%u qb=%u qbth=%u qbtl=%u tmask=0x%x " ONU_CRLF, (int)fct_ret, out.index, out.qe, out.qdth, out.qrth, out.qb, out.qbth, out.qbtl, out.tmask);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ingress_queue_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqueue in;
	struct gpe_iqueue_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ingress_queue_status_get" ONU_CRLF
		"Short Form: gpeiqsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t qf" ONU_CRLF
		"- uint32_t bp" ONU_CRLF
		"- uint32_t qocc" ONU_CRLF
		"- uint32_t pocc" ONU_CRLF
		"- uint32_t qdc" ONU_CRLF
		"- uint32_t tick" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ingress_queue_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u qf=%u bp=%u qocc=%u pocc=%u qdc=%u tick=%u " ONU_CRLF, (int)fct_ret, out.index, out.qf, out.bp, out.qocc, out.pocc, out.qdc, out.tick);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue_create param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_create" ONU_CRLF
		"Short Form: gpeeqc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t egress_port_number" ONU_CRLF
		"- uint32_t scheduler_input" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.index, &param.egress_port_number, &param.scheduler_input);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_delete" ONU_CRLF
		"Short Form: gpeeqd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue in;
	struct gpe_equeue_create out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_get" ONU_CRLF
		"Short Form: gpeeqg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t egress_port_number" ONU_CRLF
		"- uint32_t scheduler_input" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u egress_port_number=%u scheduler_input=%u " ONU_CRLF, (int)fct_ret, out.index, out.egress_port_number, out.scheduler_input);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_cfg_set" ONU_CRLF
		"Short Form: gpeeqcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t sbin_enable" ONU_CRLF
		"- uint32_t weight" ONU_CRLF
		"- uint32_t wred_enable" ONU_CRLF
		"- uint32_t avg_weight" ONU_CRLF
		"- uint32_t size" ONU_CRLF
		"- uint32_t reservation_threshold" ONU_CRLF
		"- uint32_t drop_threshold_red" ONU_CRLF
		"- uint32_t drop_threshold_green_max" ONU_CRLF
		"- uint32_t drop_threshold_green_min" ONU_CRLF
		"- uint32_t drop_threshold_yellow_max" ONU_CRLF
		"- uint32_t drop_threshold_yellow_min" ONU_CRLF
		"- uint32_t drop_probability_green" ONU_CRLF
		"- uint32_t drop_probability_yellow" ONU_CRLF
		"- enum gpe_coloring_mode coloring_mode" ONU_CRLF
		"   GPE_COLORING_MODE_NONE = 0" "\n"
		"   GPE_COLORING_MODE_INTERNAL = 1" "\n"
		"   GPE_COLORING_MODE_DEI = 2" "\n"
		"   GPE_COLORING_MODE_PCP8B0D = 3" "\n"
		"   GPE_COLORING_MODE_PCP7B1D = 4" "\n"
		"   GPE_COLORING_MODE_PCP6B2D = 5" "\n"
		"   GPE_COLORING_MODE_PCP5B3D = 6" "\n"
		"   GPE_COLORING_MODE_DSCP = 7" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u", &param.index, &param.enable, &param.sbin_enable, &param.weight, &param.wred_enable, &param.avg_weight, &param.size, &param.reservation_threshold, &param.drop_threshold_red, &param.drop_threshold_green_max, &param.drop_threshold_green_min, &param.drop_threshold_yellow_max, &param.drop_threshold_yellow_min, &param.drop_probability_green, &param.drop_probability_yellow, &param.coloring_mode);
	if (ret != 16) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue in;
	struct gpe_equeue_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_cfg_get" ONU_CRLF
		"Short Form: gpeeqcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t sbin_enable" ONU_CRLF
		"- uint32_t weight" ONU_CRLF
		"- uint32_t wred_enable" ONU_CRLF
		"- uint32_t avg_weight" ONU_CRLF
		"- uint32_t size" ONU_CRLF
		"- uint32_t reservation_threshold" ONU_CRLF
		"- uint32_t drop_threshold_red" ONU_CRLF
		"- uint32_t drop_threshold_green_max" ONU_CRLF
		"- uint32_t drop_threshold_green_min" ONU_CRLF
		"- uint32_t drop_threshold_yellow_max" ONU_CRLF
		"- uint32_t drop_threshold_yellow_min" ONU_CRLF
		"- uint32_t drop_probability_green" ONU_CRLF
		"- uint32_t drop_probability_yellow" ONU_CRLF
		"- enum gpe_coloring_mode coloring_mode" ONU_CRLF
		"   GPE_COLORING_MODE_NONE = 0" "\n"
		"   GPE_COLORING_MODE_INTERNAL = 1" "\n"
		"   GPE_COLORING_MODE_DEI = 2" "\n"
		"   GPE_COLORING_MODE_PCP8B0D = 3" "\n"
		"   GPE_COLORING_MODE_PCP7B1D = 4" "\n"
		"   GPE_COLORING_MODE_PCP6B2D = 5" "\n"
		"   GPE_COLORING_MODE_PCP5B3D = 6" "\n"
		"   GPE_COLORING_MODE_DSCP = 7" "\n"
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u enable=%u sbin_enable=%u weight=%u wred_enable=%u avg_weight=%u size=%u reservation_threshold=%u drop_threshold_red=%u drop_threshold_green_max=%u drop_threshold_green_min=%u drop_threshold_yellow_max=%u drop_threshold_yellow_min=%u drop_probability_green=%u drop_probability_yellow=%u coloring_mode=%u " ONU_CRLF, (int)fct_ret, out.index, out.enable, out.sbin_enable, out.weight, out.wred_enable, out.avg_weight, out.size, out.reservation_threshold, out.drop_threshold_red, out.drop_threshold_green_max, out.drop_threshold_green_min, out.drop_threshold_yellow_max, out.drop_threshold_yellow_min, out.drop_probability_green, out.drop_probability_yellow, out.coloring_mode);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue in;
	struct gpe_equeue_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_status_get" ONU_CRLF
		"Short Form: gpeeqsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t config_opt" ONU_CRLF
		"- uint32_t fill_max" ONU_CRLF
		"- uint32_t fill" ONU_CRLF
		"- uint32_t fill_avg" ONU_CRLF
		"- uint32_t frames" ONU_CRLF
		"- uint32_t iwgt" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u config_opt=%u fill_max=%u fill=%u fill_avg=%u frames=%u iwgt=%u " ONU_CRLF, (int)fct_ret, out.index, out.config_opt, out.fill_max, out.fill, out.fill_avg, out.frames, out.iwgt);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_queue_path_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_equeue in;
	struct gpe_equeue_path out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_queue_path_get" ONU_CRLF
		"Short Form: gpeeqpg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t lvl" ONU_CRLF
		"- uint32_t sbid" ONU_CRLF
		"- uint32_t qe" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		"- uint32_t omid" ONU_CRLF
		"- uint32_t epe" ONU_CRLF
		"- uint32_t sbid" ONU_CRLF
		"- uint32_t leaf" ONU_CRLF
		"- uint32_t sie" ONU_CRLF
		"- uint32_t sit" ONU_CRLF
		"- uint32_t iwgt" ONU_CRLF
		"- uint32_t qsid" ONU_CRLF
		"- uint32_t soe" ONU_CRLF
		"- uint32_t lvl" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_queue_path_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d lvl=%u sbid=%u qe=%u epn=%u omid=%u epe=%u sbid=%u leaf=%u sie=%u sit=%u iwgt=%u qsid=%u soe=%u lvl=%u " ONU_CRLF, (int)fct_ret, out.lvl, out.sbid, out.qe, out.epn, out.omid, out.epe, out.info[0].sbid, out.info[0].leaf, out.info[0].sie, out.info[0].sit, out.info[0].iwgt, out.info[0].qsid, out.info[0].soe, out.info[0].lvl);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_sched_create param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_create" ONU_CRLF
		"Short Form: gpesc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t use_tcont" ONU_CRLF
		"- uint32_t level" ONU_CRLF
		"- uint32_t scheduler_id" ONU_CRLF
		"- uint32_t port_idx" ONU_CRLF
		"- uint32_t connected_scheduler_index" ONU_CRLF
		"- uint32_t use_regular" ONU_CRLF
		"- enum gpe_policy scheduler_policy" ONU_CRLF
		"   GPE_POLICY_NULL = 0" "\n"
		"   GPE_POLICY_HOL = 1" "\n"
		"   GPE_POLICY_WRR = 2" "\n"
		"- uint32_t priority_weight" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u %u %u", &param.index, &param.use_tcont, &param.level, &param.scheduler_id, &param.port_idx, &param.connected_scheduler_index, &param.use_regular, &param.scheduler_policy, &param.priority_weight);
	if (ret != 9) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_scheduler_idx param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_delete" ONU_CRLF
		"Short Form: gpesd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_scheduler_idx in;
	struct gpe_sched_create out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t use_tcont" ONU_CRLF
		"- uint32_t level" ONU_CRLF
		"- uint32_t scheduler_id" ONU_CRLF
		"- uint32_t port_idx" ONU_CRLF
		"- uint32_t connected_scheduler_index" ONU_CRLF
		"- uint32_t use_regular" ONU_CRLF
		"- enum gpe_policy scheduler_policy" ONU_CRLF
		"   GPE_POLICY_NULL = 0" "\n"
		"   GPE_POLICY_HOL = 1" "\n"
		"   GPE_POLICY_WRR = 2" "\n"
		"- uint32_t priority_weight" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u use_tcont=%u level=%u scheduler_id=%u port_idx=%u connected_scheduler_index=%u use_regular=%u scheduler_policy=%u priority_weight=%u " ONU_CRLF, (int)fct_ret, out.index, out.use_tcont, out.level, out.scheduler_id, out.port_idx, out.connected_scheduler_index, out.use_regular, out.scheduler_policy, out.priority_weight);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_scheduler_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_cfg_set" ONU_CRLF
		"Short Form: gpescs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t output_enable" ONU_CRLF
		"- uint32_t weight" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.index, &param.output_enable, &param.weight);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_scheduler_idx in;
	struct gpe_scheduler_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_cfg_get" ONU_CRLF
		"Short Form: gpescg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t output_enable" ONU_CRLF
		"- uint32_t weight" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u output_enable=%u weight=%u " ONU_CRLF, (int)fct_ret, out.index, out.output_enable, out.weight);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_scheduler_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_scheduler_idx in;
	struct gpe_scheduler_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_scheduler_status_get" ONU_CRLF
		"Short Form: gpessg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t sof" ONU_CRLF
		"- uint32_t wl" ONU_CRLF
		"- uint32_t wqid" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_scheduler_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u sof=%u wl=%u wqid=%u " ONU_CRLF, (int)fct_ret, out.index, out.sof, out.wl, out.wqid);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_create" ONU_CRLF
		"Short Form: gpetbsc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t tbs_scheduler_block_input" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.index, &param.tbs_scheduler_block_input);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_delete" ONU_CRLF
		"Short Form: gpetbsd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t tbs_scheduler_block_input" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.index, &param.tbs_scheduler_block_input);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper_idx in;
	struct gpe_token_bucket_shaper out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_get" ONU_CRLF
		"Short Form: gpetbsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t tbs_scheduler_block_input" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u tbs_scheduler_block_input=%u " ONU_CRLF, (int)fct_ret, out.index, out.tbs_scheduler_block_input);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_cfg_set" ONU_CRLF
		"Short Form: gpetbscs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t mode" ONU_CRLF
		"- uint32_t cir" ONU_CRLF
		"- uint32_t pir" ONU_CRLF
		"- uint32_t cbs" ONU_CRLF
		"- uint32_t pbs" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u", &param.index, &param.enable, &param.mode, &param.cir, &param.pir, &param.cbs, &param.pbs);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper_idx in;
	struct gpe_token_bucket_shaper_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_cfg_get" ONU_CRLF
		"Short Form: gpetbscg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		"- uint32_t mode" ONU_CRLF
		"- uint32_t cir" ONU_CRLF
		"- uint32_t pir" ONU_CRLF
		"- uint32_t cbs" ONU_CRLF
		"- uint32_t pbs" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u enable=%u mode=%u cir=%u pir=%u cbs=%u pbs=%u " ONU_CRLF, (int)fct_ret, out.index, out.enable, out.mode, out.cir, out.pir, out.cbs, out.pbs);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_token_bucket_shaper_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_token_bucket_shaper_idx in;
	struct gpe_token_bucket_shaper_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_token_bucket_shaper_status_get" ONU_CRLF
		"Short Form: gpetbssg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t pass0" ONU_CRLF
		"- uint32_t pass1" ONU_CRLF
		"- uint32_t src0" ONU_CRLF
		"- uint32_t src1" ONU_CRLF
		"- uint32_t tbc0" ONU_CRLF
		"- uint32_t tbc1" ONU_CRLF
		"- uint32_t col" ONU_CRLF
		"- uint32_t qosl" ONU_CRLF
		"- uint32_t ts_tacc" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_token_bucket_shaper_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u pass0=%u pass1=%u src0=%u src1=%u tbc0=%u tbc1=%u col=%u qosl=%u ts_tacc=%u " ONU_CRLF, (int)fct_ret, out.index, out.pass0, out.pass1, out.src0, out.src1, out.tbc0, out.tbc1, out.col, out.qosl, out.ts_tacc);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_meter_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_meter param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_meter_create" ONU_CRLF
		"Short Form: gpemc" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_meter_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d index=%u " ONU_CRLF, (int)fct_ret, param.index);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_meter_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_meter param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_meter_delete" ONU_CRLF
		"Short Form: gpemd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_meter_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_meter_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_meter_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_meter_cfg_set" ONU_CRLF
		"Short Form: gpemcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t cir" ONU_CRLF
		"- uint32_t pir" ONU_CRLF
		"- uint32_t cbs" ONU_CRLF
		"- uint32_t pbs" ONU_CRLF
		"- uint32_t color_aware" ONU_CRLF
		"- enum gpe_metering_mode mode" ONU_CRLF
		"   GPE_METER_NONE = 0" "\n"
		"   GPE_METER_RFC4115 = 1" "\n"
		"   GPE_METER_RFC2698 = 2" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %u", &param.index, &param.cir, &param.pir, &param.cbs, &param.pbs, &param.color_aware, &param.mode);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_meter_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_meter_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_meter in;
	struct gpe_meter_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_meter_cfg_get" ONU_CRLF
		"Short Form: gpemcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t cir" ONU_CRLF
		"- uint32_t pir" ONU_CRLF
		"- uint32_t cbs" ONU_CRLF
		"- uint32_t pbs" ONU_CRLF
		"- uint32_t color_aware" ONU_CRLF
		"- enum gpe_metering_mode mode" ONU_CRLF
		"   GPE_METER_NONE = 0" "\n"
		"   GPE_METER_RFC4115 = 1" "\n"
		"   GPE_METER_RFC2698 = 2" "\n"
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_meter_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u cir=%u pir=%u cbs=%u pbs=%u color_aware=%u mode=%u " ONU_CRLF, (int)fct_ret, out.index, out.cir, out.pir, out.cbs, out.pbs, out.color_aware, out.mode);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_meter_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_meter in;
	struct gpe_meter_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_meter_status_get" ONU_CRLF
		"Short Form: gpemsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t tbc" ONU_CRLF
		"- uint32_t lts" ONU_CRLF
		"- uint32_t ets" ONU_CRLF
		"- uint32_t vts" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_meter_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u tbc=%u lts=%u ets=%u vts=%u " ONU_CRLF, (int)fct_ret, out.index, out.tbc, out.lts, out.ets, out.vts);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_shared_buffer_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_shared_buffer_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_shared_buffer_cfg_set" ONU_CRLF
		"Short Form: gpesbcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t iqm_global_segments_max" ONU_CRLF
		"- uint32_t tmu_global_segments_max" ONU_CRLF
		"- uint32_t tmu_global_segments_green" ONU_CRLF
		"- uint32_t tmu_global_segments_yellow" ONU_CRLF
		"- uint32_t tmu_global_segments_red" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u", &param.iqm_global_segments_max, &param.tmu_global_segments_max, &param.tmu_global_segments_green, &param.tmu_global_segments_yellow, &param.tmu_global_segments_red);
	if (ret != 5) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_shared_buffer_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_shared_buffer_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_shared_buffer_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_shared_buffer_cfg_get" ONU_CRLF
		"Short Form: gpesbcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t iqm_global_segments_max" ONU_CRLF
		"- uint32_t tmu_global_segments_max" ONU_CRLF
		"- uint32_t tmu_global_segments_green" ONU_CRLF
		"- uint32_t tmu_global_segments_yellow" ONU_CRLF
		"- uint32_t tmu_global_segments_red" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_shared_buffer_cfg_get(p_dev, &out);
	return sprintf(p_out, "errorcode=%d iqm_global_segments_max=%u tmu_global_segments_max=%u tmu_global_segments_green=%u tmu_global_segments_yellow=%u tmu_global_segments_red=%u " ONU_CRLF, (int)fct_ret, out.iqm_global_segments_max, out.tmu_global_segments_max, out.tmu_global_segments_green, out.tmu_global_segments_yellow, out.tmu_global_segments_red);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_cnt_interval in;
	struct gpe_bridge_counter out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_counter_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &in.bridge_index, &in.reset_mask, &in.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d bridge_index=%u reset_mask=%u curr=%u learning_discard=%llu " ONU_CRLF, (int)fct_ret, out.cnt_ctrl.bridge_index, out.cnt_ctrl.reset_mask, out.cnt_ctrl.curr, out.cnt_val.learning_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_port_cnt_interval in;
	struct gpe_bridge_port_counter out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_counter_get" ONU_CRLF
		"Short Form: gpebpcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		"- uint64_t ibp_good" ONU_CRLF
		"- uint64_t ibp_discard" ONU_CRLF
		"- uint64_t ebp_good" ONU_CRLF
		"- uint64_t ebp_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &in.index, &in.reset_mask, &in.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u reset_mask=%u curr=%u learning_discard=%llu ibp_good=%llu ibp_discard=%llu ebp_good=%llu ebp_discard=%llu " ONU_CRLF, (int)fct_ret, out.ctrl.index, out.ctrl.reset_mask, out.ctrl.curr, out.val.learning_discard, out.val.ibp_good, out.val.ibp_discard, out.val.ebp_good, out.val.ebp_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_counter_threshold_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_bridge_threshold param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_counter_threshold_set" ONU_CRLF
		"Short Form: gpebcts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu", &param.bridge_index, &param.threshold.learning_discard);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_counter_threshold_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_counter_threshold_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_bridge_port_threshold param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_counter_threshold_set" ONU_CRLF
		"Short Form: gpebpcts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		"- uint64_t ibp_good" ONU_CRLF
		"- uint64_t ibp_discard" ONU_CRLF
		"- uint64_t ebp_good" ONU_CRLF
		"- uint64_t ebp_discard" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu %llu %llu %llu %llu", &param.index, &param.threshold.learning_discard, &param.threshold.ibp_good, &param.threshold.ibp_discard, &param.threshold.ebp_good, &param.threshold.ebp_discard);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_counter_threshold_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_counter_threshold_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge in;
	struct gpe_cnt_bridge_threshold out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_counter_threshold_get" ONU_CRLF
		"Short Form: gpebctg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.bridge_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_counter_threshold_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d bridge_index=%u learning_discard=%llu " ONU_CRLF, (int)fct_ret, out.bridge_index, out.threshold.learning_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_counter_threshold_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_port_index in;
	struct gpe_cnt_bridge_port_threshold out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_counter_threshold_get" ONU_CRLF
		"Short Form: gpebpctg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		"- uint64_t ibp_good" ONU_CRLF
		"- uint64_t ibp_discard" ONU_CRLF
		"- uint64_t ebp_good" ONU_CRLF
		"- uint64_t ebp_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_counter_threshold_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u learning_discard=%llu ibp_good=%llu ibp_discard=%llu ebp_good=%llu ebp_discard=%llu " ONU_CRLF, (int)fct_ret, out.index, out.threshold.learning_discard, out.threshold.ibp_good, out.threshold.ibp_discard, out.threshold.ebp_good, out.threshold.ebp_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_tca_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge in;
	struct gpe_cnt_bridge_threshold out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_tca_get" ONU_CRLF
		"Short Form: gpebtg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.bridge_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_tca_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d bridge_index=%u learning_discard=%llu " ONU_CRLF, (int)fct_ret, out.bridge_index, out.threshold.learning_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_tca_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_port_index in;
	struct gpe_cnt_bridge_port_threshold out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_tca_get" ONU_CRLF
		"Short Form: gpebptg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t learning_discard" ONU_CRLF
		"- uint64_t ibp_good" ONU_CRLF
		"- uint64_t ibp_discard" ONU_CRLF
		"- uint64_t ebp_good" ONU_CRLF
		"- uint64_t ebp_discard" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_tca_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u learning_discard=%llu ibp_good=%llu ibp_discard=%llu ebp_good=%llu ebp_discard=%llu " ONU_CRLF, (int)fct_ret, out.index, out.threshold.learning_discard, out.threshold.ibp_good, out.threshold.ibp_discard, out.threshold.ebp_good, out.threshold.ebp_discard);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_cnt_interval param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_counter_reset" ONU_CRLF
		"Short Form: gpebcr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.bridge_index, &param.reset_mask, &param.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_port_cnt_interval param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_counter_reset" ONU_CRLF
		"Short Form: gpebpcr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.index, &param.reset_mask, &param.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_parser_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_parser_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_parser_cfg_set" ONU_CRLF
		"Short Form: gpepcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tpid[4]" ONU_CRLF
		"- uint32_t special_tag" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u[4] %u", &param.tpid[0], &param.special_tag);
	if (ret != 5) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_parser_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_parser_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_parser_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_parser_cfg_get" ONU_CRLF
		"Short Form: gpepcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tpid[4]" ONU_CRLF
		"- uint32_t special_tag" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_parser_cfg_get(p_dev, &out);
	return sprintf(p_out, "errorcode=%d tpid=\"%u %u %u %u\" special_tag=%u " ONU_CRLF, (int)fct_ret, out.tpid[0], out.tpid[1], out.tpid[2], out.tpid[3], out.special_tag);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ethertype_filter_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ethertype_filter_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ethertype_filter_cfg_set" ONU_CRLF
		"Short Form: gpeefcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t lanport_index" ONU_CRLF
		"- uint32_t ethertype_filter_pointer" ONU_CRLF
		"- uint32_t ethertype[32]" ONU_CRLF
		"- uint32_t num_valid_ethertypes" ONU_CRLF
		"- uint32_t whitelist_mode" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u[32] %u %u", &param.lanport_index, &param.ethertype_filter_pointer, &param.ethertype[0], &param.num_valid_ethertypes, &param.whitelist_mode);
	if (ret != 36) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ethertype_filter_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ethertype_filter_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ethertype_filter_index in;
	struct gpe_ethertype_filter_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ethertype_filter_cfg_get" ONU_CRLF
		"Short Form: gpeefcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t lanport_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t lanport_index" ONU_CRLF
		"- uint32_t ethertype_filter_pointer" ONU_CRLF
		"- uint32_t ethertype[32]" ONU_CRLF
		"- uint32_t num_valid_ethertypes" ONU_CRLF
		"- uint32_t whitelist_mode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.lanport_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ethertype_filter_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d lanport_index=%u ethertype_filter_pointer=%u ethertype=\"%u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u\" num_valid_ethertypes=%u whitelist_mode=%u " ONU_CRLF, (int)fct_ret, out.lanport_index, out.ethertype_filter_pointer, out.ethertype[0], out.ethertype[1], out.ethertype[2], out.ethertype[3], out.ethertype[4], out.ethertype[5], out.ethertype[6], out.ethertype[7], out.ethertype[8], out.ethertype[9], out.ethertype[10], out.ethertype[11], out.ethertype[12], out.ethertype[13], out.ethertype[14], out.ethertype[15], out.ethertype[16], out.ethertype[17], out.ethertype[18], out.ethertype[19], out.ethertype[20], out.ethertype[21], out.ethertype[22], out.ethertype[23], out.ethertype[24], out.ethertype[25], out.ethertype[26], out.ethertype[27], out.ethertype[28], out.ethertype[29], out.ethertype[30], out.ethertype[31], out.num_valid_ethertypes, out.whitelist_mode);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_omci_send(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_omci_msg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_omci_send" ONU_CRLF
		"Short Form: gpeos" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t length" ONU_CRLF
		"- uint8_t message[1980]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %bu[1980]", &param.length, &param.message[0]);
	if (ret != 1981) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_omci_send(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tod_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tod_init_data param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tod_init" ONU_CRLF
		"Short Form: gpeti" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t pps_pulse_width" ONU_CRLF
		"- uint32_t interrupt_delay" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.pps_pulse_width, &param.interrupt_delay);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tod_init(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tod_sync_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tod_sync param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tod_sync_set" ONU_CRLF
		"Short Form: gpetss" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t multiframe_count" ONU_CRLF
		"- uint32_t tod_seconds" ONU_CRLF
		"- uint32_t tod_extended_seconds" ONU_CRLF
		"- uint32_t tod_nano_seconds" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u", &param.multiframe_count, &param.tod_seconds, &param.tod_extended_seconds, &param.tod_nano_seconds);
	if (ret != 4) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tod_sync_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tod_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tod param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tod_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t sec" ONU_CRLF
		"- uint32_t min" ONU_CRLF
		"- uint32_t hour" ONU_CRLF
		"- uint32_t mday" ONU_CRLF
		"- uint32_t mon" ONU_CRLF
		"- uint32_t year" ONU_CRLF
		"- uint32_t wday" ONU_CRLF
		"- uint32_t yday" ONU_CRLF
		"- uint32_t sec_tai" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_tod_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d sec=%u min=%u hour=%u mday=%u mon=%u year=%u wday=%u yday=%u sec_tai=%u " ONU_CRLF, (int)fct_ret, param.sec, param.min, param.hour, param.mday, param.mon, param.year, param.wday, param.yday, param.sec_tai);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tod_sync_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tod_sync param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tod_sync_get" ONU_CRLF
		"Short Form: gpetsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t multiframe_count" ONU_CRLF
		"- uint32_t tod_seconds" ONU_CRLF
		"- uint32_t tod_extended_seconds" ONU_CRLF
		"- uint32_t tod_nano_seconds" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_tod_sync_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d multiframe_count=%u tod_seconds=%u tod_extended_seconds=%u tod_nano_seconds=%u " ONU_CRLF, (int)fct_ret, param.multiframe_count, param.tod_seconds, param.tod_extended_seconds, param.tod_nano_seconds);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_iqm_global_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqm_global_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_iqm_global_cfg_set" ONU_CRLF
		"Short Form: gpeigcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t goth" ONU_CRLF
		"- uint32_t wrrper" ONU_CRLF
		"- uint32_t wrrq[36]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u[36]", &param.goth, &param.wrrper, &param.wrrq[0]);
	if (ret != 38) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_iqm_global_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_iqm_global_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqm_global_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_iqm_global_cfg_get" ONU_CRLF
		"Short Form: gpeigcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t goth" ONU_CRLF
		"- uint32_t wrrper" ONU_CRLF
		"- uint32_t wrrq[36]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_iqm_global_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d goth=%u wrrper=%u wrrq=\"%u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.goth, param.wrrper, param.wrrq[0], param.wrrq[1], param.wrrq[2], param.wrrq[3], param.wrrq[4], param.wrrq[5], param.wrrq[6], param.wrrq[7], param.wrrq[8], param.wrrq[9], param.wrrq[10], param.wrrq[11], param.wrrq[12], param.wrrq[13], param.wrrq[14], param.wrrq[15], param.wrrq[16], param.wrrq[17], param.wrrq[18], param.wrrq[19], param.wrrq[20], param.wrrq[21], param.wrrq[22], param.wrrq[23], param.wrrq[24], param.wrrq[25], param.wrrq[26], param.wrrq[27], param.wrrq[28], param.wrrq[29], param.wrrq[30], param.wrrq[31], param.wrrq[32], param.wrrq[33], param.wrrq[34], param.wrrq[35]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_iqm_global_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_iqm_global_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_iqm_global_status_get" ONU_CRLF
		"Short Form: gpeigsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gocc" ONU_CRLF
		"- uint32_t gpdc" ONU_CRLF
		"- uint32_t sfree0" ONU_CRLF
		"- uint32_t sfree1" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_iqm_global_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d gocc=%u gpdc=%u sfree0=0x%x sfree1=0x%x " ONU_CRLF, (int)fct_ret, param.gocc, param.gpdc, param.sfree0, param.sfree1);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tmu_global_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tmu_global_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tmu_global_cfg_get" ONU_CRLF
		"Short Form: gpetgcg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t rps" ONU_CRLF
		"- uint32_t dta" ONU_CRLF
		"- uint32_t maxtb" ONU_CRLF
		"- uint32_t lfsr" ONU_CRLF
		"- uint32_t cp" ONU_CRLF
		"- uint32_t erd" ONU_CRLF
		"- uint32_t tacp" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_tmu_global_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d rps=%u dta=%u maxtb=%u lfsr=%u cp=%u erd=%u tacp=%u " ONU_CRLF, (int)fct_ret, param.rps, param.dta, param.maxtb, param.lfsr, param.cp, param.erd, param.tacp);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tmu_global_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_tmu_global_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tmu_global_status_get" ONU_CRLF
		"Short Form: gpetgsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t fpcr" ONU_CRLF
		"- uint32_t gocc" ONU_CRLF
		"- uint32_t gpdc[4]" ONU_CRLF
		"- uint32_t qfill[8]" ONU_CRLF
		"- uint32_t epf[3]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_tmu_global_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d fpcr=%u gocc=%u gpdc=\"%u %u %u %u\" qfill=\"0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x\" epf=\"0x%x 0x%x 0x%x\" " ONU_CRLF, (int)fct_ret, param.fpcr, param.gocc, param.gpdc[0], param.gpdc[1], param.gpdc[2], param.gpdc[3], param.qfill[0], param.qfill[1], param.qfill[2], param.qfill[3], param.qfill[4], param.qfill[5], param.qfill[6], param.qfill[7], param.epf[0], param.epf[1], param.epf[2]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tmu_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_tmu_sel in;
	struct gpe_cnt_tmu_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tmu_counter_get" ONU_CRLF
		"Short Form: gpetcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum gpe_tmu_cnt_type cnt_type" ONU_CRLF
		"   GPE_TMU_COUNTER_EGRESS_QUEUE = 0" "\n"
		"   GPE_TMU_COUNTER_INGRESS_QUEUE = 1" "\n"
		"   GPE_TMU_COUNTER_TCONT = 2" "\n"
		"   GPE_TMU_COUNTER_UNI = 3" "\n"
		"   GPE_TMU_COUNTER_VUNI = 4" "\n"
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- enum gpe_tmu_cnt_type cnt_type" ONU_CRLF
		"   GPE_TMU_COUNTER_EGRESS_QUEUE = 0" "\n"
		"   GPE_TMU_COUNTER_INGRESS_QUEUE = 1" "\n"
		"   GPE_TMU_COUNTER_TCONT = 2" "\n"
		"   GPE_TMU_COUNTER_UNI = 3" "\n"
		"   GPE_TMU_COUNTER_VUNI = 4" "\n"
		"- uint32_t index" ONU_CRLF
		"- uint32_t dropped_frames[4]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.cnt_type, &in.index);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tmu_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d cnt_type=%u index=%u dropped_frames=\"%u %u %u %u\" " ONU_CRLF, (int)fct_ret, out.cnt_type, out.index, out.dropped_frames[0], out.dropped_frames[1], out.dropped_frames[2], out.dropped_frames[3]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_tmu_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_tmu_reset param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_tmu_counter_reset" ONU_CRLF
		"Short Form: gpetcr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t dummy" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.dummy);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_tmu_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_sce_sel in;
	struct gpe_cnt_sce_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_counter_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum gpe_sce_cnt_type cnt_type" ONU_CRLF
		"   GPE_SCE_UNICAST = 0" "\n"
		"   GPE_SCE_BROADCAST = 1" "\n"
		"   GPE_SCE_MULTICAST = 2" "\n"
		"   GPE_SCE_DISCARDED = 3" "\n"
		"   GPE_SCE_LEARNING_FAIL = 4" "\n"
		"   GPE_SCE_ACCEPTED_INGRESS = 5" "\n"
		"   GPE_SCE_ACCEPTED_EGRESS = 6" "\n"
		"   GPE_SCE_DISCARDED_INGRESS = 7" "\n"
		"   GPE_SCE_DISCARDED_EGRESS = 8" "\n"
		"   GPE_SCE_DISCARDED_PPPOE = 9" "\n"
		"   GPE_SCE_EXCEPTION_POLICER = 10" "\n"
		"   GPE_SCE_EXCEPTION_LOST = 11" "\n"
		"   GPE_SCE_BROADCAST_EGRESS = 12" "\n"
		"   GPE_SCE_MULTICAST_EGRESS = 13" "\n"
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- enum gpe_sce_cnt_type cnt_type" ONU_CRLF
		"   GPE_SCE_UNICAST = 0" "\n"
		"   GPE_SCE_BROADCAST = 1" "\n"
		"   GPE_SCE_MULTICAST = 2" "\n"
		"   GPE_SCE_DISCARDED = 3" "\n"
		"   GPE_SCE_LEARNING_FAIL = 4" "\n"
		"   GPE_SCE_ACCEPTED_INGRESS = 5" "\n"
		"   GPE_SCE_ACCEPTED_EGRESS = 6" "\n"
		"   GPE_SCE_DISCARDED_INGRESS = 7" "\n"
		"   GPE_SCE_DISCARDED_EGRESS = 8" "\n"
		"   GPE_SCE_DISCARDED_PPPOE = 9" "\n"
		"   GPE_SCE_EXCEPTION_POLICER = 10" "\n"
		"   GPE_SCE_EXCEPTION_LOST = 11" "\n"
		"   GPE_SCE_BROADCAST_EGRESS = 12" "\n"
		"   GPE_SCE_MULTICAST_EGRESS = 13" "\n"
		"- uint32_t index" ONU_CRLF
		"- uint32_t counter" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.cnt_type, &in.index);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d cnt_type=%u index=%u counter=%u " ONU_CRLF, (int)fct_ret, out.cnt_type, out.index, out.counter);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_sce_reset param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_counter_reset" ONU_CRLF
		"Short Form: gpescr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t dummy" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.dummy);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_gem_cnt_interval in;
	struct gpe_gem_counter out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_counter_get" ONU_CRLF
		"Short Form: gpegcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &in.gem_port_index, &in.reset_mask, &in.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d gem_port_index=%u reset_mask=%u curr=%u rx_frames=%llu rx_bytes=%llu tx_frames=%llu tx_bytes=%llu " ONU_CRLF, (int)fct_ret, out.cnt_ctrl.gem_port_index, out.cnt_ctrl.reset_mask, out.cnt_ctrl.curr, out.cnt_val.rx.rx_frames, out.cnt_val.rx.rx_bytes, out.cnt_val.tx.tx_frames, out.cnt_val.tx.tx_bytes);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_counter_threshold_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cnt_gem_threshold param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_counter_threshold_set" ONU_CRLF
		"Short Form: gpegcts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu %llu %llu %llu", &param.gem_port_index, &param.threshold.rx.rx_frames, &param.threshold.rx.rx_bytes, &param.threshold.tx.tx_frames, &param.threshold.tx.tx_bytes);
	if (ret != 5) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_counter_threshold_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_counter_threshold_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gem_port_index in;
	struct gpe_cnt_gem_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_counter_threshold_get" ONU_CRLF
		"Short Form: gpegctg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.val);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_counter_threshold_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d rx_frames=%llu rx_bytes=%llu tx_frames=%llu tx_bytes=%llu " ONU_CRLF, (int)fct_ret, out.rx.rx_frames, out.rx.rx_bytes, out.tx.tx_frames, out.tx.tx_bytes);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_tca_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gem_port_index in;
	struct gpe_gem_tca_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_tca_get" ONU_CRLF
		"Short Form: gpegtg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.val);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_tca_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d val=%u rx_frames=%llu rx_bytes=%llu tx_frames=%llu tx_bytes=%llu " ONU_CRLF, (int)fct_ret, out.index.val, out.cnt_val.rx.rx_frames, out.cnt_val.rx.rx_bytes, out.cnt_val.tx.tx_frames, out.cnt_val.tx.tx_bytes);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_gem_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_gem_cnt_interval param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_gem_counter_reset" ONU_CRLF
		"Short Form: gpegcr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.gem_port_index, &param.reset_mask, &param.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_gem_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

#if defined(INCLUDE_SCE_DEBUG)
/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_break_point param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break_set" ONU_CRLF
		"Short Form: scebs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.tid, &param.addr);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break_autocheck_enable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	bool enable;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break_autocheck_enable" ONU_CRLF
		"Short Form: scebae" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- bool enable \n   false = 0\n   true = 1" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu", &enable);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break_autocheck_enable(p_dev, enable);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_break_index in;
	struct sce_break_point out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break_get" ONU_CRLF
		"Short Form: scebg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t idx" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.tid, &in.idx);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d tid=%u addr=0x%x " ONU_CRLF, (int)fct_ret, out.tid, out.addr);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break_remove(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_break_point param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break_remove" ONU_CRLF
		"Short Form: scebr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.tid, &param.addr);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break_remove(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_thread in;
	struct sce_break_info out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break" ONU_CRLF
		"Short Form: sceb" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.tid);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d addr=0x%x " ONU_CRLF, (int)fct_ret, out.addr);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_single_step(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_thread in;
	struct sce_break_info out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_single_step" ONU_CRLF
		"Short Form: scess" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.tid);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_single_step(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d addr=0x%x " ONU_CRLF, (int)fct_ret, out.addr);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_run(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_thread param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_run" ONU_CRLF
		"Short Form: scer" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.tid);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_run(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_restart_vm(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_restart_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_restart_vm" ONU_CRLF
		"Short Form: scerv" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t pid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.pid);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_restart_vm(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_run_mask(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_thread_mask param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_run_mask" ONU_CRLF
		"Short Form: scerm" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t mask" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.mask);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_run_mask(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_break_mask(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_thread_mask param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_break_mask" ONU_CRLF
		"Short Form: scebm" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t mask" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.mask);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_break_mask(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_status param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_status_get" ONU_CRLF
		"Short Form: scesg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tstat0" ONU_CRLF
		"- uint32_t terr" ONU_CRLF
		"- uint32_t tctrl0" ONU_CRLF
		"- uint32_t tdebug0" ONU_CRLF
		"- uint32_t bctrl0" ONU_CRLF
		"- uint32_t bstat0" ONU_CRLF
		"- uint32_t bdis0" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = sce_status_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d tstat0=0x%x terr=0x%x tctrl0=0x%x tdebug0=0x%x bctrl0=0x%x bstat0=0x%x bdis0=0x%x " ONU_CRLF, (int)fct_ret, param.tstat0, param.terr, param.tctrl0, param.tdebug0, param.bctrl0, param.bstat0, param.bdis0);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_reg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_register_val param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_reg_set" ONU_CRLF
		"Short Form: scers" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t reg" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.tid, &param.reg, &param.val);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_reg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_reg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_register in;
	struct sce_register_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_reg_get" ONU_CRLF
		"Short Form: scerg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t reg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t reg" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.tid, &in.reg);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_reg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d tid=%u reg=%u val=0x%x " ONU_CRLF, (int)fct_ret, out.tid, out.reg, out.val);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_mem_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_memory_val param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_mem_set" ONU_CRLF
		"Short Form: scems" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.tid, &param.addr, &param.val);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_mem_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_sce_mem_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_memory in;
	struct sce_memory_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: sce_mem_get" ONU_CRLF
		"Short Form: scemg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t tid" ONU_CRLF
		"- uint32_t addr" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.tid, &in.addr);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = sce_mem_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d tid=%u addr=0x%x val=0x%x " ONU_CRLF, (int)fct_ret, out.tid, out.addr, out.val);
}

#endif /* defined(INCLUDE_SCE_DEBUG) */
/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_download(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_download_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_download" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t pid" ONU_CRLF
		"- char fw_name[32]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %s", &param.pid, &param.fw_name);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_download(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_version_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_pe_index in;
	struct sce_version out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_version_get" ONU_CRLF
		"Short Form: gpesvg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t pid" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t pid" ONU_CRLF
		"- uint8_t data[4]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.pid);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_version_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d pid=%u data=\"%u %u %u %u\" " ONU_CRLF, (int)fct_ret, out.pid, out.data[0], out.data[1], out.data[2], out.data[3]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_flat_egress_path_create(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_flat_egress_path param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_flat_egress_path_create" ONU_CRLF
		"Short Form: gpefepc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t num_ports" ONU_CRLF
		"- uint32_t base_epn" ONU_CRLF
		"- uint32_t base_sbid" ONU_CRLF
		"- uint32_t base_qid" ONU_CRLF
		"- uint32_t qid_per_sb" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u", &param.num_ports, &param.base_epn, &param.base_sbid, &param.base_qid, &param.qid_per_sb);
	if (ret != 5) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_flat_egress_path_create(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_fsqm_check(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	uint16_t len;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_fsqm_check" ONU_CRLF
		"Short Form: gpefc" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint16_t len" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%hu", &len);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_fsqm_check(p_dev, len);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_cop_download(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct cop_download_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_cop_download" ONU_CRLF
		"Short Form: gpecd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t cop_id" ONU_CRLF
		"- char mc_name[32]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %s", &param.cop_id, &param.mc_name);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_cop_download(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_lan_exception_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_lan_exception_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_lan_exception_cfg_set" ONU_CRLF
		"Short Form: gpelecs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t exception_profile" ONU_CRLF
		"- uint32_t uni_except_meter_id" ONU_CRLF
		"- uint32_t uni_except_meter_enable" ONU_CRLF
		"- uint32_t igmp_except_meter_id" ONU_CRLF
		"- uint32_t igmp_except_meter_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u", &param.lan_port_index, &param.exception_profile, &param.uni_except_meter_id, &param.uni_except_meter_enable, &param.igmp_except_meter_id, &param.igmp_except_meter_enable);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_lan_exception_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_lan_exception_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_lan_exception_idx in;
	struct gpe_lan_exception_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_lan_exception_cfg_get" ONU_CRLF
		"Short Form: gpelecg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t exception_profile" ONU_CRLF
		"- uint32_t uni_except_meter_id" ONU_CRLF
		"- uint32_t uni_except_meter_enable" ONU_CRLF
		"- uint32_t igmp_except_meter_id" ONU_CRLF
		"- uint32_t igmp_except_meter_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.lan_port_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_lan_exception_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d lan_port_index=%u exception_profile=%u uni_except_meter_id=%u uni_except_meter_enable=%u igmp_except_meter_id=%u igmp_except_meter_enable=%u " ONU_CRLF, (int)fct_ret, out.lan_port_index, out.exception_profile, out.uni_except_meter_id, out.uni_except_meter_enable, out.igmp_except_meter_id, out.igmp_except_meter_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ani_exception_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ani_exception_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ani_exception_cfg_set" ONU_CRLF
		"Short Form: gpeaecs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t ds_exception_profile" ONU_CRLF
		"- uint32_t us_exception_profile" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.gem_port_index, &param.ds_exception_profile, &param.us_exception_profile);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ani_exception_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_ani_exception_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ani_exception_idx in;
	struct gpe_ani_exception_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_ani_exception_cfg_get" ONU_CRLF
		"Short Form: gpeaecg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t gem_port_index" ONU_CRLF
		"- uint32_t ds_exception_profile" ONU_CRLF
		"- uint32_t us_exception_profile" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.gem_port_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_ani_exception_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d gem_port_index=%u ds_exception_profile=%u us_exception_profile=%u " ONU_CRLF, (int)fct_ret, out.gem_port_index, out.ds_exception_profile, out.us_exception_profile);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_exception_queue_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_exception_queue_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_exception_queue_cfg_set" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t exception_index" ONU_CRLF
		"- uint32_t exception_queue" ONU_CRLF
		"- uint32_t snooping_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.exception_index, &param.exception_queue, &param.snooping_enable);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_exception_queue_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_exception_queue_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_exception_queue_idx in;
	struct gpe_exception_queue_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_exception_queue_cfg_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t exception_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t exception_index" ONU_CRLF
		"- uint32_t exception_queue" ONU_CRLF
		"- uint32_t snooping_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.exception_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_exception_queue_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d exception_index=%u exception_queue=%u snooping_enable=%u " ONU_CRLF, (int)fct_ret, out.exception_index, out.exception_queue, out.snooping_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_lan_port_acl_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_lan_port_acl in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_lan_port_acl_set" ONU_CRLF
		"Short Form: gpelpas" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint16_t port_index" ONU_CRLF
		"- bool acl_filter_enable \n   false = 0\n   true = 1" ONU_CRLF
		"- uint8_t acl_filter_index" ONU_CRLF
		"- bool acl_filter_mode_whitelist \n   false = 0\n   true = 1" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%hu %bu %bu %bu", &in.port_index, &in.acl_filter_enable, &in.acl_filter_index, &in.acl_filter_mode_whitelist);
	if (ret != 4) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_lan_port_acl_set(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_lan_port_acl_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_lan_port_acl_index in;
	struct gpe_lan_port_acl out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_lan_port_acl_get" ONU_CRLF
		"Short Form: gpelpag" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint16_t port_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint16_t port_index" ONU_CRLF
		"- bool acl_filter_enable \n   false = 0\n   true = 1" ONU_CRLF
		"- uint8_t acl_filter_index" ONU_CRLF
		"- bool acl_filter_mode_whitelist \n   false = 0\n   true = 1" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%hu", &in.port_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_lan_port_acl_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d port_index=%hu acl_filter_enable=%u acl_filter_index=%u acl_filter_mode_whitelist=%u " ONU_CRLF, (int)fct_ret, out.port_index, out.acl_filter_enable, out.acl_filter_index, out.acl_filter_mode_whitelist);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_capability_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_capability param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_capability_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t max_meter" ONU_CRLF
		"- uint32_t max_gpix" ONU_CRLF
		"- uint32_t max_eth_uni" ONU_CRLF
		"- uint32_t max_pots_uni" ONU_CRLF
		"- uint32_t max_bridge_port" ONU_CRLF
		"- uint32_t hw_version" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_capability_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d max_meter=%u max_gpix=%u max_eth_uni=%u max_pots_uni=%u max_bridge_port=%u hw_version=%u " ONU_CRLF, (int)fct_ret, param.max_meter, param.max_gpix, param.max_eth_uni, param.max_pots_uni, param.max_bridge_port, param.hw_version);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_exception_profile_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_exception_profile_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_exception_profile_cfg_set" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t exception_profile" ONU_CRLF
		"- uint32_t ingress_exception_mask" ONU_CRLF
		"- uint32_t egress_exception_mask" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u", &param.exception_profile, &param.ingress_exception_mask, &param.egress_exception_mask);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_exception_profile_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_exception_profile_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_exception_profile_idx in;
	struct gpe_exception_profile_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_exception_profile_cfg_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t exception_profile" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t exception_profile" ONU_CRLF
		"- uint32_t ingress_exception_mask" ONU_CRLF
		"- uint32_t egress_exception_mask" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.exception_profile);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_exception_profile_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d exception_profile=%u ingress_exception_mask=%u egress_exception_mask=%u " ONU_CRLF, (int)fct_ret, out.exception_profile, out.ingress_exception_mask, out.egress_exception_mask);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_enable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_epn param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_enable" ONU_CRLF
		"Short Form: gpeepe" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.epn);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_enable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_egress_port_disable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_epn param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_egress_port_disable" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t epn" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.epn);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_egress_port_disable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_mac_mc_port_add(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_mac_mc_port in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_mac_mc_port_add" ONU_CRLF
		"Short Form: gpesfmmpa" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t mc_mac[6]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %bu[6]", &in.fid, &in.lan_port_index, &in.igmp, &in.mc_mac[0]);
	if (ret != 9) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_mac_mc_port_add(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_mac_mc_port_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_mac_mc_port in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_mac_mc_port_delete" ONU_CRLF
		"Short Form: gpesfmmpd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t mc_mac[6]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %bu[6]", &in.fid, &in.lan_port_index, &in.igmp, &in.mc_mac[0]);
	if (ret != 9) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_mac_mc_port_delete(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_mac_mc_port_modify(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_mac_mc_port_modify in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_mac_mc_port_modify" ONU_CRLF
		"Short Form: gpesfmmpm" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t port_map_index" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t mc_mac[6]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %bu[6]", &in.bridge_index, &in.port_map_index, &in.fid, &in.igmp, &in.mc_mac[0]);
	if (ret != 10) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_mac_mc_port_modify(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_ipv4_mc_port_add(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ipv4_mc_port in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_ipv4_mc_port_add" ONU_CRLF
		"Short Form: gpesfi4mpa" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t ip[4]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %bu[4]", &in.fid, &in.lan_port_index, &in.igmp, &in.ip[0]);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_ipv4_mc_port_add(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_ipv4_mc_port_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ipv4_mc_port in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_ipv4_mc_port_delete" ONU_CRLF
		"Short Form: gpesfi4mpd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t lan_port_index" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t ip[4]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %bu[4]", &in.fid, &in.lan_port_index, &in.igmp, &in.ip[0]);
	if (ret != 7) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_ipv4_mc_port_delete(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_short_fwd_ipv4_mc_port_modify(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_ipv4_mc_port_modify in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_short_fwd_ipv4_mc_port_modify" ONU_CRLF
		"Short Form: gpesfi4mpm" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t port_map_index" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		"- uint32_t igmp" ONU_CRLF
		"- uint8_t ip[4]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %bu[4]", &in.bridge_index, &in.port_map_index, &in.fid, &in.igmp, &in.ip[0]);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_short_fwd_ipv4_mc_port_modify(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_aging_time_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_aging_time in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_aging_time_set" ONU_CRLF
		"Short Form: gpeats" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t aging_time" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.aging_time);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_aging_time_set(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_aging_time_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_aging_time out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_aging_time_get" ONU_CRLF
		"Short Form: gpeatg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t aging_time" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_aging_time_get(p_dev, &out);
	return sprintf(p_out, "errorcode=%d aging_time=%u " ONU_CRLF, (int)fct_ret, out.aging_time);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_aging_time_set_debug(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct sce_aging_time in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_aging_time_set_debug" ONU_CRLF
		"Short Form: gpeatsd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t aging_time" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.aging_time);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_aging_time_set_debug(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_constants_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_sce_constants param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_constants_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t packet_processing_enable" ONU_CRLF
		"- uint32_t default_fid" ONU_CRLF
		"- uint16_t default_outer_vid" ONU_CRLF
		"- uint16_t default_inner_vid" ONU_CRLF
		"- uint32_t default_dscp" ONU_CRLF
		"- uint32_t unused0" ONU_CRLF
		"- uint32_t fwd_table_size" ONU_CRLF
		"- uint16_t tpid_a" ONU_CRLF
		"- uint16_t tpid_b" ONU_CRLF
		"- uint16_t tpid_c" ONU_CRLF
		"- uint16_t tpid_d" ONU_CRLF
		"- uint32_t unused" ONU_CRLF
		"- uint32_t added_latency" ONU_CRLF
		"- uint32_t unused1" ONU_CRLF
		"- uint8_t local_cpu_mac[6]" ONU_CRLF
		"- uint32_t ani_exception_meter_id" ONU_CRLF
		"- uint32_t ani_exception_enable" ONU_CRLF
		"- uint32_t ani_except_policer_threshold" ONU_CRLF
		"- uint32_t uni_except_policer_threshold" ONU_CRLF
		"- uint32_t igmp_except_policer_threshold" ONU_CRLF
		"- uint32_t meter_l2_only_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_sce_constants_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d packet_processing_enable=%u default_fid=%u default_outer_vid=%hu default_inner_vid=%hu default_dscp=%u unused0=%u fwd_table_size=%u tpid_a=%hu tpid_b=%hu tpid_c=%hu tpid_d=%hu unused=%u added_latency=%u unused1=%u local_cpu_mac=\"%u %u %u %u %u %u\" ani_exception_meter_id=%u ani_exception_enable=%u ani_except_policer_threshold=%u uni_except_policer_threshold=%u igmp_except_policer_threshold=%u meter_l2_only_enable=%u " ONU_CRLF, (int)fct_ret, param.packet_processing_enable, param.default_fid, param.default_outer_vid, param.default_inner_vid, param.default_dscp, param.unused0, param.fwd_table_size, param.tpid_a, param.tpid_b, param.tpid_c, param.tpid_d, param.unused, param.added_latency, param.unused1, param.local_cpu_mac[0], param.local_cpu_mac[1], param.local_cpu_mac[2], param.local_cpu_mac[3], param.local_cpu_mac[4], param.local_cpu_mac[5], param.ani_exception_meter_id, param.ani_exception_enable, param.ani_except_policer_threshold, param.uni_except_policer_threshold, param.igmp_except_policer_threshold, param.meter_l2_only_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_constants_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_sce_constants param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_constants_set" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t packet_processing_enable" ONU_CRLF
		"- uint32_t default_fid" ONU_CRLF
		"- uint16_t default_outer_vid" ONU_CRLF
		"- uint16_t default_inner_vid" ONU_CRLF
		"- uint32_t default_dscp" ONU_CRLF
		"- uint32_t unused0" ONU_CRLF
		"- uint32_t fwd_table_size" ONU_CRLF
		"- uint16_t tpid_a" ONU_CRLF
		"- uint16_t tpid_b" ONU_CRLF
		"- uint16_t tpid_c" ONU_CRLF
		"- uint16_t tpid_d" ONU_CRLF
		"- uint32_t unused" ONU_CRLF
		"- uint32_t added_latency" ONU_CRLF
		"- uint32_t unused1" ONU_CRLF
		"- uint8_t local_cpu_mac[6]" ONU_CRLF
		"- uint32_t ani_exception_meter_id" ONU_CRLF
		"- uint32_t ani_exception_enable" ONU_CRLF
		"- uint32_t ani_except_policer_threshold" ONU_CRLF
		"- uint32_t uni_except_policer_threshold" ONU_CRLF
		"- uint32_t igmp_except_policer_threshold" ONU_CRLF
		"- uint32_t meter_l2_only_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %hu %hu %u %u %u %hu %hu %hu %hu %u %u %u %bu[6] %u %u %u %u %u %u", &param.packet_processing_enable, &param.default_fid, &param.default_outer_vid, &param.default_inner_vid, &param.default_dscp, &param.unused0, &param.fwd_table_size, &param.tpid_a, &param.tpid_b, &param.tpid_c, &param.tpid_d, &param.unused, &param.added_latency, &param.unused1, &param.local_cpu_mac[0], &param.ani_exception_meter_id, &param.ani_exception_enable, &param.ani_except_policer_threshold, &param.uni_except_policer_threshold, &param.igmp_except_policer_threshold, &param.meter_l2_only_enable);
	if (ret != 26) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_constants_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_mac_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_sce_mac param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_mac_get" ONU_CRLF
		"Short Form: gpesmg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t local_cpu_mac[6]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = gpe_sce_mac_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d local_cpu_mac=\"%u %u %u %u %u %u\" " ONU_CRLF, (int)fct_ret, param.local_cpu_mac[0], param.local_cpu_mac[1], param.local_cpu_mac[2], param.local_cpu_mac[3], param.local_cpu_mac[4], param.local_cpu_mac[5]);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_sce_mac_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_sce_mac param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_sce_mac_set" ONU_CRLF
		"Short Form: gpesms" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t local_cpu_mac[6]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu[6]", &param.local_cpu_mac[0]);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_sce_mac_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_vlan_fid_add(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_vlan_fid_in in;
	struct gpe_vlan_fid_out out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_vlan_fid_add" ONU_CRLF
		"Short Form: gpevfa" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t vlan_1" ONU_CRLF
		"- uint32_t vlan_2" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.vlan_1, &in.vlan_2);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_vlan_fid_add(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d fid=%u " ONU_CRLF, (int)fct_ret, out.fid);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_vlan_fid_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_vlan_fid_in in;
	struct gpe_vlan_fid_out out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_vlan_fid_get" ONU_CRLF
		"Short Form: gpevfg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t vlan_1" ONU_CRLF
		"- uint32_t vlan_2" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t fid" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.vlan_1, &in.vlan_2);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_vlan_fid_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d fid=%u " ONU_CRLF, (int)fct_ret, out.fid);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_vlan_fid_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_vlan_fid_in in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_vlan_fid_delete" ONU_CRLF
		"Short Form: gpevfd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t vlan_1" ONU_CRLF
		"- uint32_t vlan_2" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.vlan_1, &in.vlan_2);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_vlan_fid_delete(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_bridge_port_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_bridge_port_index in;
	struct gpe_bridge_port out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_bridge_port_cfg_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t valid" ONU_CRLF
		"- uint32_t unused5" ONU_CRLF
		"- uint32_t tp_type" ONU_CRLF
		"- uint32_t tp_pointer" ONU_CRLF
		"- uint32_t unused4" ONU_CRLF
		"- uint32_t dscp_table_pointer" ONU_CRLF
		"- uint32_t egress_filter_mask" ONU_CRLF
		"- uint32_t meter_id_egress" ONU_CRLF
		"- uint32_t tagging_filter_egress" ONU_CRLF
		"- uint32_t meter_id_ingress" ONU_CRLF
		"- uint32_t tagging_filter_ingress" ONU_CRLF
		"- uint32_t da_filter_pointer" ONU_CRLF
		"- uint32_t sa_filter_pointer" ONU_CRLF
		"- uint32_t unused3" ONU_CRLF
		"- uint32_t egress_color_marking" ONU_CRLF
		"- uint32_t ingress_color_marking" ONU_CRLF
		"- uint32_t da_filter_mode" ONU_CRLF
		"- uint32_t sa_filter_mode" ONU_CRLF
		"- uint32_t port_state" ONU_CRLF
		"- uint32_t unused2" ONU_CRLF
		"- uint32_t bridge_index" ONU_CRLF
		"- uint32_t forwarding_method" ONU_CRLF
		"- uint32_t umc_flood_disable" ONU_CRLF
		"- uint32_t meter_egress_enable" ONU_CRLF
		"- uint32_t meter_ingress_enable" ONU_CRLF
		"- uint32_t tagging_filter_egress_enable" ONU_CRLF
		"- uint32_t tagging_filter_ingress_enable" ONU_CRLF
		"- uint32_t uuc_flood_disable" ONU_CRLF
		"- uint32_t local_switching_enable" ONU_CRLF
		"- uint32_t port_lock_enable" ONU_CRLF
		"- uint32_t learning_enable" ONU_CRLF
		"- uint32_t learning_limit" ONU_CRLF
		"- uint32_t association_count" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_bridge_port_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u valid=%u unused5=%u tp_type=%u tp_pointer=%u unused4=%u dscp_table_pointer=%u egress_filter_mask=%u meter_id_egress=%u tagging_filter_egress=%u meter_id_ingress=%u tagging_filter_ingress=%u da_filter_pointer=%u sa_filter_pointer=%u unused3=%u egress_color_marking=%u ingress_color_marking=%u da_filter_mode=%u sa_filter_mode=%u port_state=%u unused2=%u bridge_index=%u forwarding_method=%u umc_flood_disable=%u meter_egress_enable=%u meter_ingress_enable=%u tagging_filter_egress_enable=%u tagging_filter_ingress_enable=%u uuc_flood_disable=%u local_switching_enable=%u port_lock_enable=%u learning_enable=%u learning_limit=%u association_count=%u " ONU_CRLF, (int)fct_ret, out.index, out.gpe_bridge_port_tbl.valid, out.gpe_bridge_port_tbl.unused5, out.gpe_bridge_port_tbl.tp_type, out.gpe_bridge_port_tbl.tp_pointer, out.gpe_bridge_port_tbl.unused4, out.gpe_bridge_port_tbl.dscp_table_pointer, out.gpe_bridge_port_tbl.egress_filter_mask, out.gpe_bridge_port_tbl.meter_id_egress, out.gpe_bridge_port_tbl.tagging_filter_egress, out.gpe_bridge_port_tbl.meter_id_ingress, out.gpe_bridge_port_tbl.tagging_filter_ingress, out.gpe_bridge_port_tbl.da_filter_pointer, out.gpe_bridge_port_tbl.sa_filter_pointer, out.gpe_bridge_port_tbl.unused3, out.gpe_bridge_port_tbl.egress_color_marking, out.gpe_bridge_port_tbl.ingress_color_marking, out.gpe_bridge_port_tbl.da_filter_mode, out.gpe_bridge_port_tbl.sa_filter_mode, out.gpe_bridge_port_tbl.port_state, out.gpe_bridge_port_tbl.unused2, out.gpe_bridge_port_tbl.bridge_index, out.gpe_bridge_port_tbl.forwarding_method, out.gpe_bridge_port_tbl.umc_flood_disable, out.gpe_bridge_port_tbl.meter_egress_enable, out.gpe_bridge_port_tbl.meter_ingress_enable, out.gpe_bridge_port_tbl.tagging_filter_egress_enable, out.gpe_bridge_port_tbl.tagging_filter_ingress_enable, out.gpe_bridge_port_tbl.uuc_flood_disable, out.gpe_bridge_port_tbl.local_switching_enable, out.gpe_bridge_port_tbl.port_lock_enable, out.gpe_bridge_port_tbl.learning_enable, out.gpe_learning_limitation_tbl.learning_limit, out.gpe_learning_limitation_tbl.association_count);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_cop_debug_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cop_tracing in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_cop_debug_set" ONU_CRLF
		"Short Form: gpecds" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t cop_idx" ONU_CRLF
		"- uint32_t trace_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.cop_idx, &in.trace_enable);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_cop_debug_set(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_cop_debug_server(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_cop_debug in;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_cop_debug_server" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t copmsk" ONU_CRLF
		"- uint32_t stepcnt" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &in.copmsk, &in.stepcnt);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_cop_debug_server(p_dev, &in);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_acl_table_entry_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_acl_table_entry param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_acl_table_entry_set" ONU_CRLF
		"Short Form: gpeates" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t acl_filter_index" ONU_CRLF
		"- uint32_t last_entry" ONU_CRLF
		"- uint8_t param1[16]" ONU_CRLF
		"- uint8_t param2[6]" ONU_CRLF
		"- uint32_t param1_mask" ONU_CRLF
		"- enum gpe_acl_param1_type param1_type" ONU_CRLF
		"   GPE_ACL_PARAM1_NONE = 0" "\n"
		"   GPE_ACL_PARAM1_IPV4_SA = 1" "\n"
		"   GPE_ACL_PARAM1_IPV4_DA = 2" "\n"
		"   GPE_ACL_PARAM1_IPV4_PROT = 3" "\n"
		"   GPE_ACL_PARAM1_IPV6_SA = 4" "\n"
		"   GPE_ACL_PARAM1_IPV6_DA = 5" "\n"
		"- enum gpe_acl_param2_type param2_type" ONU_CRLF
		"   GPE_ACL_PARAM2_NONE = 0" "\n"
		"   GPE_ACL_PARAM2_MAC_SA = 1" "\n"
		"   GPE_ACL_PARAM2_MAC_DA = 2" "\n"
		"   GPE_ACL_PARAM2_ETHERTYPE = 3" "\n"
		"   GPE_ACL_PARAM2_TCP_SP = 4" "\n"
		"   GPE_ACL_PARAM2_TCP_DP = 5" "\n"
		"   GPE_ACL_PARAM2_UDP_SP = 6" "\n"
		"   GPE_ACL_PARAM2_UDP_DP = 7" "\n"
		"   GPE_ACL_PARAM2_TCP_UDP_SP = 8" "\n"
		"   GPE_ACL_PARAM2_TCP_UDP_DP = 9" "\n"
		"- uint32_t fid" ONU_CRLF
		"- uint32_t fid_en" ONU_CRLF
		"- uint32_t ingress_port_enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %bu[16] %bu[6] %u %u %u %u %u %u", &param.acl_filter_index, &param.last_entry, &param.param1[0], &param.param2[0], &param.param1_mask, &param.param1_type, &param.param2_type, &param.fid, &param.fid_en, &param.ingress_port_enable);
	if (ret != 30) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_acl_table_entry_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_acl_table_entry_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_acl_table_entry_idx in;
	struct gpe_acl_table_entry out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_acl_table_entry_get" ONU_CRLF
		"Short Form: gpeateg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t acl_filter_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t acl_filter_index" ONU_CRLF
		"- uint32_t last_entry" ONU_CRLF
		"- uint8_t param1[16]" ONU_CRLF
		"- uint8_t param2[6]" ONU_CRLF
		"- uint32_t param1_mask" ONU_CRLF
		"- enum gpe_acl_param1_type param1_type" ONU_CRLF
		"   GPE_ACL_PARAM1_NONE = 0" "\n"
		"   GPE_ACL_PARAM1_IPV4_SA = 1" "\n"
		"   GPE_ACL_PARAM1_IPV4_DA = 2" "\n"
		"   GPE_ACL_PARAM1_IPV4_PROT = 3" "\n"
		"   GPE_ACL_PARAM1_IPV6_SA = 4" "\n"
		"   GPE_ACL_PARAM1_IPV6_DA = 5" "\n"
		"- enum gpe_acl_param2_type param2_type" ONU_CRLF
		"   GPE_ACL_PARAM2_NONE = 0" "\n"
		"   GPE_ACL_PARAM2_MAC_SA = 1" "\n"
		"   GPE_ACL_PARAM2_MAC_DA = 2" "\n"
		"   GPE_ACL_PARAM2_ETHERTYPE = 3" "\n"
		"   GPE_ACL_PARAM2_TCP_SP = 4" "\n"
		"   GPE_ACL_PARAM2_TCP_DP = 5" "\n"
		"   GPE_ACL_PARAM2_UDP_SP = 6" "\n"
		"   GPE_ACL_PARAM2_UDP_DP = 7" "\n"
		"   GPE_ACL_PARAM2_TCP_UDP_SP = 8" "\n"
		"   GPE_ACL_PARAM2_TCP_UDP_DP = 9" "\n"
		"- uint32_t fid" ONU_CRLF
		"- uint32_t fid_en" ONU_CRLF
		"- uint32_t ingress_port_enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu", &in.acl_filter_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_acl_table_entry_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d acl_filter_index=%u last_entry=%u param1=\"%u %u %u %u %u %u %u %u %u %u %u %u %u %u %u %u\" param2=\"%u %u %u %u %u %u\" param1_mask=%u param1_type=%u param2_type=%u fid=%u fid_en=%u ingress_port_enable=%u " ONU_CRLF, (int)fct_ret, out.acl_filter_index, out.last_entry, out.param1[0], out.param1[1], out.param1[2], out.param1[3], out.param1[4], out.param1[5], out.param1[6], out.param1[7], out.param1[8], out.param1[9], out.param1[10], out.param1[11], out.param1[12], out.param1[13], out.param1[14], out.param1[15], out.param2[0], out.param2[1], out.param2[2], out.param2[3], out.param2[4], out.param2[5], out.param1_mask, out.param1_type, out.param2_type, out.fid, out.fid_en, out.ingress_port_enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_gpe_acl_table_entry_delete(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct gpe_acl_table_entry_idx param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: gpe_acl_table_entry_delete" ONU_CRLF
		"Short Form: gpeated" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t acl_filter_index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu", &param.acl_filter_index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = gpe_acl_table_entry_delete(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_gphy_firmware_download(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_gphy_fw param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_gphy_firmware_download" ONU_CRLF
		"Short Form: langfd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- char fw_name[128]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%s", &param.fw_name);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_gphy_firmware_download(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_init" ONU_CRLF
		"Short Form: lani" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = lan_init(p_dev);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_cfg_set" ONU_CRLF
		"Short Form: lancs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum lan_interface_mux_mode mux_mode" ONU_CRLF
		"   LAN_MUX_UNDEFINED = 0" "\n"
		"   LAN_MUX_FEPHY4 = 1" "\n"
		"   LAN_MUX_GPHY2_RGMII2 = 2" "\n"
		"   LAN_MUX_GPHY2_RGMII_SGMII = 3" "\n"
		"   LAN_MUX_GPHY2_GMII_SGMII = 4" "\n"
		"   LAN_MUX_GPHY_RGMII2_SGMII = 5" "\n"
		"   LAN_MUX_RGMII2_SGMII = 6" "\n"
		"   LAN_MUX_RGMII1 = 7" "\n"
		"   LAN_MUX_MII = 99" "\n"
		"- int8_t mdio_dev_addr[4]" ONU_CRLF
		"- enum mdio_mode_speed mdio_data_rate" ONU_CRLF
		"   MDIO_MODE_SPEED_UNDEFINED = -1" "\n"
		"   MDIO_MODE_SPEED_2M5 = 0" "\n"
		"   MDIO_MODE_SPEED_5M = 1" "\n"
		"   MDIO_MODE_SPEED_10M = 2" "\n"
		"   MDIO_MODE_SPEED_20M = 3" "\n"
		"- uint32_t mdio_short_preamble_en" ONU_CRLF
		"- uint32_t mdio_en" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %bd[4] %u %u %u", &param.mux_mode, &param.mdio_dev_addr[0], &param.mdio_data_rate, &param.mdio_short_preamble_en, &param.mdio_en);
	if (ret != 8) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_cfg_get" ONU_CRLF
		"Short Form: lancg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- enum lan_interface_mux_mode mux_mode" ONU_CRLF
		"   LAN_MUX_UNDEFINED = 0" "\n"
		"   LAN_MUX_FEPHY4 = 1" "\n"
		"   LAN_MUX_GPHY2_RGMII2 = 2" "\n"
		"   LAN_MUX_GPHY2_RGMII_SGMII = 3" "\n"
		"   LAN_MUX_GPHY2_GMII_SGMII = 4" "\n"
		"   LAN_MUX_GPHY_RGMII2_SGMII = 5" "\n"
		"   LAN_MUX_RGMII2_SGMII = 6" "\n"
		"   LAN_MUX_RGMII1 = 7" "\n"
		"   LAN_MUX_MII = 99" "\n"
		"- int8_t mdio_dev_addr[4]" ONU_CRLF
		"- enum mdio_mode_speed mdio_data_rate" ONU_CRLF
		"   MDIO_MODE_SPEED_UNDEFINED = -1" "\n"
		"   MDIO_MODE_SPEED_2M5 = 0" "\n"
		"   MDIO_MODE_SPEED_5M = 1" "\n"
		"   MDIO_MODE_SPEED_10M = 2" "\n"
		"   MDIO_MODE_SPEED_20M = 3" "\n"
		"- uint32_t mdio_short_preamble_en" ONU_CRLF
		"- uint32_t mdio_en" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = lan_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d mux_mode=%u mdio_dev_addr=\"%d %d %d %d\" mdio_data_rate=%u mdio_short_preamble_en=%u mdio_en=%u " ONU_CRLF, (int)fct_ret, param.mux_mode, param.mdio_dev_addr[0], param.mdio_dev_addr[1], param.mdio_dev_addr[2], param.mdio_dev_addr[3], param.mdio_data_rate, param.mdio_short_preamble_en, param.mdio_en);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_cfg_set" ONU_CRLF
		"Short Form: lanpcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t uni_port_en" ONU_CRLF
		"- enum lan_mode_interface mode" ONU_CRLF
		"   LAN_MODE_OFF = 0" "\n"
		"   LAN_MODE_GPHY = 1" "\n"
		"   LAN_MODE_EPHY = 2" "\n"
		"   LAN_MODE_SGMII_SLOW = 3" "\n"
		"   LAN_MODE_SGMII_FAST = 4" "\n"
		"   LAN_MODE_RGMII_MAC = 5" "\n"
		"   LAN_MODE_RMII_MAC = 6" "\n"
		"   LAN_MODE_RMII_PHY = 7" "\n"
		"   LAN_MODE_GMII_MAC = 8" "\n"
		"   LAN_MODE_GMII_PHY = 9" "\n"
		"   LAN_MODE_MII_MAC = 10" "\n"
		"   LAN_MODE_MII_PHY = 11" "\n"
		"   LAN_MODE_TMII_MAC = 12" "\n"
		"   LAN_MODE_TMII_PHY = 13" "\n"
		"   LAN_MODE_TBI_MAC = 14" "\n"
		"   LAN_MODE_TBI_PHY = 15" "\n"
		"- enum lan_mode_duplex duplex_mode" ONU_CRLF
		"   LAN_PHY_MODE_DUPLEX_AUTO = 0" "\n"
		"   LAN_PHY_MODE_DUPLEX_FULL = 1" "\n"
		"   LAN_PHY_MODE_DUPLEX_HALF = 2" "\n"
		"- enum lan_mode_flow_control flow_control_mode" ONU_CRLF
		"   LAN_FLOW_CONTROL_MODE_AUTO = 0" "\n"
		"   LAN_FLOW_CONTROL_MODE_RX = 1" "\n"
		"   LAN_FLOW_CONTROL_MODE_TX = 2" "\n"
		"   LAN_FLOW_CONTROL_MODE_RXTX = 3" "\n"
		"   LAN_FLOW_CONTROL_MODE_NONE = 4" "\n"
		"- enum lan_mode_speed speed_mode" ONU_CRLF
		"   LAN_MODE_SPEED_AUTO = 0" "\n"
		"   LAN_MODE_SPEED_10 = 1" "\n"
		"   LAN_MODE_SPEED_100 = 2" "\n"
		"   LAN_MODE_SPEED_200 = 3" "\n"
		"   LAN_MODE_SPEED_1000 = 4" "\n"
		"   LAN_MODE_SPEED_2500 = 5" "\n"
		"- uint8_t tx_clk_dly" ONU_CRLF
		"- uint8_t rx_clk_dly" ONU_CRLF
		"- uint16_t max_frame_size" ONU_CRLF
		"- uint32_t lpi_enable" ONU_CRLF
		"- enum sgmii_autoneg_mode autoneg_mode" ONU_CRLF
		"   SGMII_MAC_ANEG = 0" "\n"
		"   SGMII_PHY_ANEG = 1" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u %bu %bu %hu %u %u", &param.index, &param.uni_port_en, &param.mode, &param.duplex_mode, &param.flow_control_mode, &param.speed_mode, &param.tx_clk_dly, &param.rx_clk_dly, &param.max_frame_size, &param.lpi_enable, &param.autoneg_mode);
	if (ret != 11) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct lan_port_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_cfg_get" ONU_CRLF
		"Short Form: lanpcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t uni_port_en" ONU_CRLF
		"- enum lan_mode_interface mode" ONU_CRLF
		"   LAN_MODE_OFF = 0" "\n"
		"   LAN_MODE_GPHY = 1" "\n"
		"   LAN_MODE_EPHY = 2" "\n"
		"   LAN_MODE_SGMII_SLOW = 3" "\n"
		"   LAN_MODE_SGMII_FAST = 4" "\n"
		"   LAN_MODE_RGMII_MAC = 5" "\n"
		"   LAN_MODE_RMII_MAC = 6" "\n"
		"   LAN_MODE_RMII_PHY = 7" "\n"
		"   LAN_MODE_GMII_MAC = 8" "\n"
		"   LAN_MODE_GMII_PHY = 9" "\n"
		"   LAN_MODE_MII_MAC = 10" "\n"
		"   LAN_MODE_MII_PHY = 11" "\n"
		"   LAN_MODE_TMII_MAC = 12" "\n"
		"   LAN_MODE_TMII_PHY = 13" "\n"
		"   LAN_MODE_TBI_MAC = 14" "\n"
		"   LAN_MODE_TBI_PHY = 15" "\n"
		"- enum lan_mode_duplex duplex_mode" ONU_CRLF
		"   LAN_PHY_MODE_DUPLEX_AUTO = 0" "\n"
		"   LAN_PHY_MODE_DUPLEX_FULL = 1" "\n"
		"   LAN_PHY_MODE_DUPLEX_HALF = 2" "\n"
		"- enum lan_mode_flow_control flow_control_mode" ONU_CRLF
		"   LAN_FLOW_CONTROL_MODE_AUTO = 0" "\n"
		"   LAN_FLOW_CONTROL_MODE_RX = 1" "\n"
		"   LAN_FLOW_CONTROL_MODE_TX = 2" "\n"
		"   LAN_FLOW_CONTROL_MODE_RXTX = 3" "\n"
		"   LAN_FLOW_CONTROL_MODE_NONE = 4" "\n"
		"- enum lan_mode_speed speed_mode" ONU_CRLF
		"   LAN_MODE_SPEED_AUTO = 0" "\n"
		"   LAN_MODE_SPEED_10 = 1" "\n"
		"   LAN_MODE_SPEED_100 = 2" "\n"
		"   LAN_MODE_SPEED_200 = 3" "\n"
		"   LAN_MODE_SPEED_1000 = 4" "\n"
		"   LAN_MODE_SPEED_2500 = 5" "\n"
		"- uint8_t tx_clk_dly" ONU_CRLF
		"- uint8_t rx_clk_dly" ONU_CRLF
		"- uint16_t max_frame_size" ONU_CRLF
		"- uint32_t lpi_enable" ONU_CRLF
		"- enum sgmii_autoneg_mode autoneg_mode" ONU_CRLF
		"   SGMII_MAC_ANEG = 0" "\n"
		"   SGMII_PHY_ANEG = 1" "\n"
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u uni_port_en=%u mode=%u duplex_mode=%u flow_control_mode=%u speed_mode=%u tx_clk_dly=%u rx_clk_dly=%u max_frame_size=%hu lpi_enable=%u autoneg_mode=%u " ONU_CRLF, (int)fct_ret, out.index, out.uni_port_en, out.mode, out.duplex_mode, out.flow_control_mode, out.speed_mode, out.tx_clk_dly, out.rx_clk_dly, out.max_frame_size, out.lpi_enable, out.autoneg_mode);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_enable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_enable" ONU_CRLF
		"Short Form: lanpe" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_enable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_disable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_disable" ONU_CRLF
		"Short Form: lanpd" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_disable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_loop_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_loop_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_loop_cfg_set" ONU_CRLF
		"Short Form: lanlcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t mac_egress_loop_en" ONU_CRLF
		"- uint32_t mii_ingress_loop_en" ONU_CRLF
		"- uint32_t sgmii_ingress_loop_en" ONU_CRLF
		"- uint32_t phy_ingress_loop_en" ONU_CRLF
		"- uint32_t phy_egress_loop_en" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u %u %u %u %u", &param.index, &param.mac_egress_loop_en, &param.mii_ingress_loop_en, &param.sgmii_ingress_loop_en, &param.phy_ingress_loop_en, &param.phy_egress_loop_en);
	if (ret != 6) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_loop_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_loop_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct lan_loop_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_loop_cfg_get" ONU_CRLF
		"Short Form: lanlcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t mac_egress_loop_en" ONU_CRLF
		"- uint32_t mii_ingress_loop_en" ONU_CRLF
		"- uint32_t sgmii_ingress_loop_en" ONU_CRLF
		"- uint32_t phy_ingress_loop_en" ONU_CRLF
		"- uint32_t phy_egress_loop_en" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_loop_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u mac_egress_loop_en=%u mii_ingress_loop_en=%u sgmii_ingress_loop_en=%u phy_ingress_loop_en=%u phy_egress_loop_en=%u " ONU_CRLF, (int)fct_ret, out.index, out.mac_egress_loop_en, out.mii_ingress_loop_en, out.sgmii_ingress_loop_en, out.phy_ingress_loop_en, out.phy_egress_loop_en);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct lan_port_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_status_get" ONU_CRLF
		"Short Form: lanpsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- enum lan_mode_interface mode" ONU_CRLF
		"   LAN_MODE_OFF = 0" "\n"
		"   LAN_MODE_GPHY = 1" "\n"
		"   LAN_MODE_EPHY = 2" "\n"
		"   LAN_MODE_SGMII_SLOW = 3" "\n"
		"   LAN_MODE_SGMII_FAST = 4" "\n"
		"   LAN_MODE_RGMII_MAC = 5" "\n"
		"   LAN_MODE_RMII_MAC = 6" "\n"
		"   LAN_MODE_RMII_PHY = 7" "\n"
		"   LAN_MODE_GMII_MAC = 8" "\n"
		"   LAN_MODE_GMII_PHY = 9" "\n"
		"   LAN_MODE_MII_MAC = 10" "\n"
		"   LAN_MODE_MII_PHY = 11" "\n"
		"   LAN_MODE_TMII_MAC = 12" "\n"
		"   LAN_MODE_TMII_PHY = 13" "\n"
		"   LAN_MODE_TBI_MAC = 14" "\n"
		"   LAN_MODE_TBI_PHY = 15" "\n"
		"- uint32_t uni_port_en" ONU_CRLF
		"- enum lan_phy_status link_status" ONU_CRLF
		"   LAN_PHY_STATUS_OFF = 0" "\n"
		"   LAN_PHY_STATUS_DOWN = 1" "\n"
		"   LAN_PHY_STATUS_10_UP = 2" "\n"
		"   LAN_PHY_STATUS_100_UP = 3" "\n"
		"   LAN_PHY_STATUS_1000_UP = 4" "\n"
		"   LAN_PHY_STATUS_NONE = 5" "\n"
		"   LAN_PHY_STATUS_UNKNOWN = 255" "\n"
		"- enum lan_mode_duplex phy_duplex" ONU_CRLF
		"   LAN_PHY_MODE_DUPLEX_AUTO = 0" "\n"
		"   LAN_PHY_MODE_DUPLEX_FULL = 1" "\n"
		"   LAN_PHY_MODE_DUPLEX_HALF = 2" "\n"
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u mode=%u uni_port_en=%u link_status=%u phy_duplex=%u " ONU_CRLF, (int)fct_ret, out.index, out.mode, out.uni_port_en, out.link_status, out.phy_duplex);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_counter_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_cnt_interval in;
	struct lan_counters out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_counter_get" ONU_CRLF
		"Short Form: " CLI_EMPTY_CMD_HELP ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t rx_undersized_frames" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t rx64" ONU_CRLF
		"- uint64_t rx65" ONU_CRLF
		"- uint64_t rx128" ONU_CRLF
		"- uint64_t rx256" ONU_CRLF
		"- uint64_t rx512" ONU_CRLF
		"- uint64_t rx1024" ONU_CRLF
		"- uint64_t rx1519" ONU_CRLF
		"- uint64_t buffer_overflow" ONU_CRLF
		"- uint64_t dma_write_error" ONU_CRLF
		"- uint64_t mac_error" ONU_CRLF
		"- uint64_t rx_bc_frames" ONU_CRLF
		"- uint64_t rx_mc_frames" ONU_CRLF
		"- uint64_t rx_uc_frames" ONU_CRLF
		"- uint64_t rx_non_pppoe_frames" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		"- uint64_t tx64" ONU_CRLF
		"- uint64_t tx65" ONU_CRLF
		"- uint64_t tx128" ONU_CRLF
		"- uint64_t tx256" ONU_CRLF
		"- uint64_t tx512" ONU_CRLF
		"- uint64_t tx1024" ONU_CRLF
		"- uint64_t tx1519" ONU_CRLF
		"- uint64_t rx_fcs_err" ONU_CRLF
		"- uint64_t algn_err" ONU_CRLF
		"- uint64_t rx_frag" ONU_CRLF
		"- uint64_t rx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_frag" ONU_CRLF
		"- uint64_t tx_jabber_frames" ONU_CRLF
		"- uint64_t tx_drop_events" ONU_CRLF
		"- uint64_t tx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_mac_err" ONU_CRLF
		"- uint64_t delay_exceeded" ONU_CRLF
		"- uint64_t exc_col" ONU_CRLF
		"- uint64_t late_col" ONU_CRLF
		"- uint64_t sgl_col" ONU_CRLF
		"- uint64_t mul_col" ONU_CRLF
		"- uint64_t def_trans" ONU_CRLF
		"- uint64_t carrier_sense_err" ONU_CRLF
		"- uint64_t sqe_test" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu %u", &in.index, &in.reset_mask, &in.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_counter_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u reset_mask=%llu curr=%u rx_frames=%llu rx_bytes=%llu rx_undersized_frames=%llu rx_oversized_frames=%llu rx64=%llu rx65=%llu rx128=%llu rx256=%llu rx512=%llu rx1024=%llu rx1519=%llu buffer_overflow=%llu dma_write_error=%llu mac_error=%llu rx_bc_frames=%llu rx_mc_frames=%llu rx_uc_frames=%llu rx_non_pppoe_frames=%llu tx_frames=%llu tx_bytes=%llu tx64=%llu tx65=%llu tx128=%llu tx256=%llu tx512=%llu tx1024=%llu tx1519=%llu rx_fcs_err=%llu algn_err=%llu rx_frag=%llu rx_buff_overflow_events=%llu tx_frag=%llu tx_jabber_frames=%llu tx_drop_events=%llu tx_buff_overflow_events=%llu tx_mac_err=%llu delay_exceeded=%llu exc_col=%llu late_col=%llu sgl_col=%llu mul_col=%llu def_trans=%llu carrier_sense_err=%llu sqe_test=%llu " ONU_CRLF, (int)fct_ret, out.interval.index, out.interval.reset_mask, out.interval.curr, out.val.rx.rx_frames, out.val.rx.rx_bytes, out.val.rx.rx_undersized_frames, out.val.rx.rx_oversized_frames, out.val.rx.rx64, out.val.rx.rx65, out.val.rx.rx128, out.val.rx.rx256, out.val.rx.rx512, out.val.rx.rx1024, out.val.rx.rx1519, out.val.rx.buffer_overflow, out.val.rx.dma_write_error, out.val.rx.mac_error, out.val.sce.rx_bc_frames, out.val.sce.rx_mc_frames, out.val.sce.rx_uc_frames, out.val.sce.rx_non_pppoe_frames, out.val.tx.tx_frames, out.val.tx.tx_bytes, out.val.tx.tx64, out.val.tx.tx65, out.val.tx.tx128, out.val.tx.tx256, out.val.tx.tx512, out.val.tx.tx1024, out.val.tx.tx1519, out.val.mac.rx_fcs_err, out.val.mac.algn_err, out.val.mac.rx_frag, out.val.mac.rx_buff_overflow_events, out.val.mac.tx_frag, out.val.mac.tx_jabber_frames, out.val.mac.tx_drop_events, out.val.mac.tx_buff_overflow_events, out.val.mac.tx_mac_err, out.val.mac.delay_exceeded, out.val.mac.exc_col, out.val.mac.late_col, out.val.mac.sgl_col, out.val.mac.mul_col, out.val.mac.def_trans, out.val.mac.carrier_sense_err, out.val.mac.sqe_test);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_counter_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_cnt_interval param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_counter_reset" ONU_CRLF
		"Short Form: lancr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t reset_mask" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu %u", &param.index, &param.reset_mask, &param.curr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_counter_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_counter_threshold_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_cnt_threshold param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_counter_threshold_set" ONU_CRLF
		"Short Form: lancts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t rx_undersized_frames" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t rx64" ONU_CRLF
		"- uint64_t rx65" ONU_CRLF
		"- uint64_t rx128" ONU_CRLF
		"- uint64_t rx256" ONU_CRLF
		"- uint64_t rx512" ONU_CRLF
		"- uint64_t rx1024" ONU_CRLF
		"- uint64_t rx1519" ONU_CRLF
		"- uint64_t buffer_overflow" ONU_CRLF
		"- uint64_t dma_write_error" ONU_CRLF
		"- uint64_t mac_error" ONU_CRLF
		"- uint64_t rx_bc_frames" ONU_CRLF
		"- uint64_t rx_mc_frames" ONU_CRLF
		"- uint64_t rx_uc_frames" ONU_CRLF
		"- uint64_t rx_non_pppoe_frames" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		"- uint64_t tx64" ONU_CRLF
		"- uint64_t tx65" ONU_CRLF
		"- uint64_t tx128" ONU_CRLF
		"- uint64_t tx256" ONU_CRLF
		"- uint64_t tx512" ONU_CRLF
		"- uint64_t tx1024" ONU_CRLF
		"- uint64_t tx1519" ONU_CRLF
		"- uint64_t rx_fcs_err" ONU_CRLF
		"- uint64_t algn_err" ONU_CRLF
		"- uint64_t rx_frag" ONU_CRLF
		"- uint64_t rx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_frag" ONU_CRLF
		"- uint64_t tx_jabber_frames" ONU_CRLF
		"- uint64_t tx_drop_events" ONU_CRLF
		"- uint64_t tx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_mac_err" ONU_CRLF
		"- uint64_t delay_exceeded" ONU_CRLF
		"- uint64_t exc_col" ONU_CRLF
		"- uint64_t late_col" ONU_CRLF
		"- uint64_t sgl_col" ONU_CRLF
		"- uint64_t mul_col" ONU_CRLF
		"- uint64_t def_trans" ONU_CRLF
		"- uint64_t carrier_sense_err" ONU_CRLF
		"- uint64_t sqe_test" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu %llu", &param.index, &param.threshold.rx.rx_frames, &param.threshold.rx.rx_bytes, &param.threshold.rx.rx_undersized_frames, &param.threshold.rx.rx_oversized_frames, &param.threshold.rx.rx64, &param.threshold.rx.rx65, &param.threshold.rx.rx128, &param.threshold.rx.rx256, &param.threshold.rx.rx512, &param.threshold.rx.rx1024, &param.threshold.rx.rx1519, &param.threshold.rx.buffer_overflow, &param.threshold.rx.dma_write_error, &param.threshold.rx.mac_error, &param.threshold.sce.rx_bc_frames, &param.threshold.sce.rx_mc_frames, &param.threshold.sce.rx_uc_frames, &param.threshold.sce.rx_non_pppoe_frames, &param.threshold.tx.tx_frames, &param.threshold.tx.tx_bytes, &param.threshold.tx.tx64, &param.threshold.tx.tx65, &param.threshold.tx.tx128, &param.threshold.tx.tx256, &param.threshold.tx.tx512, &param.threshold.tx.tx1024, &param.threshold.tx.tx1519, &param.threshold.mac.rx_fcs_err, &param.threshold.mac.algn_err, &param.threshold.mac.rx_frag, &param.threshold.mac.rx_buff_overflow_events, &param.threshold.mac.tx_frag, &param.threshold.mac.tx_jabber_frames, &param.threshold.mac.tx_drop_events, &param.threshold.mac.tx_buff_overflow_events, &param.threshold.mac.tx_mac_err, &param.threshold.mac.delay_exceeded, &param.threshold.mac.exc_col, &param.threshold.mac.late_col, &param.threshold.mac.sgl_col, &param.threshold.mac.mul_col, &param.threshold.mac.def_trans, &param.threshold.mac.carrier_sense_err, &param.threshold.mac.sqe_test);
	if (ret != 45) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_counter_threshold_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_counter_threshold_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct lan_cnt_threshold out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_counter_threshold_get" ONU_CRLF
		"Short Form: lanctg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t rx_undersized_frames" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t rx64" ONU_CRLF
		"- uint64_t rx65" ONU_CRLF
		"- uint64_t rx128" ONU_CRLF
		"- uint64_t rx256" ONU_CRLF
		"- uint64_t rx512" ONU_CRLF
		"- uint64_t rx1024" ONU_CRLF
		"- uint64_t rx1519" ONU_CRLF
		"- uint64_t buffer_overflow" ONU_CRLF
		"- uint64_t dma_write_error" ONU_CRLF
		"- uint64_t mac_error" ONU_CRLF
		"- uint64_t rx_bc_frames" ONU_CRLF
		"- uint64_t rx_mc_frames" ONU_CRLF
		"- uint64_t rx_uc_frames" ONU_CRLF
		"- uint64_t rx_non_pppoe_frames" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		"- uint64_t tx64" ONU_CRLF
		"- uint64_t tx65" ONU_CRLF
		"- uint64_t tx128" ONU_CRLF
		"- uint64_t tx256" ONU_CRLF
		"- uint64_t tx512" ONU_CRLF
		"- uint64_t tx1024" ONU_CRLF
		"- uint64_t tx1519" ONU_CRLF
		"- uint64_t rx_fcs_err" ONU_CRLF
		"- uint64_t algn_err" ONU_CRLF
		"- uint64_t rx_frag" ONU_CRLF
		"- uint64_t rx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_frag" ONU_CRLF
		"- uint64_t tx_jabber_frames" ONU_CRLF
		"- uint64_t tx_drop_events" ONU_CRLF
		"- uint64_t tx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_mac_err" ONU_CRLF
		"- uint64_t delay_exceeded" ONU_CRLF
		"- uint64_t exc_col" ONU_CRLF
		"- uint64_t late_col" ONU_CRLF
		"- uint64_t sgl_col" ONU_CRLF
		"- uint64_t mul_col" ONU_CRLF
		"- uint64_t def_trans" ONU_CRLF
		"- uint64_t carrier_sense_err" ONU_CRLF
		"- uint64_t sqe_test" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_counter_threshold_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u rx_frames=%llu rx_bytes=%llu rx_undersized_frames=%llu rx_oversized_frames=%llu rx64=%llu rx65=%llu rx128=%llu rx256=%llu rx512=%llu rx1024=%llu rx1519=%llu buffer_overflow=%llu dma_write_error=%llu mac_error=%llu rx_bc_frames=%llu rx_mc_frames=%llu rx_uc_frames=%llu rx_non_pppoe_frames=%llu tx_frames=%llu tx_bytes=%llu tx64=%llu tx65=%llu tx128=%llu tx256=%llu tx512=%llu tx1024=%llu tx1519=%llu rx_fcs_err=%llu algn_err=%llu rx_frag=%llu rx_buff_overflow_events=%llu tx_frag=%llu tx_jabber_frames=%llu tx_drop_events=%llu tx_buff_overflow_events=%llu tx_mac_err=%llu delay_exceeded=%llu exc_col=%llu late_col=%llu sgl_col=%llu mul_col=%llu def_trans=%llu carrier_sense_err=%llu sqe_test=%llu " ONU_CRLF, (int)fct_ret, out.index, out.threshold.rx.rx_frames, out.threshold.rx.rx_bytes, out.threshold.rx.rx_undersized_frames, out.threshold.rx.rx_oversized_frames, out.threshold.rx.rx64, out.threshold.rx.rx65, out.threshold.rx.rx128, out.threshold.rx.rx256, out.threshold.rx.rx512, out.threshold.rx.rx1024, out.threshold.rx.rx1519, out.threshold.rx.buffer_overflow, out.threshold.rx.dma_write_error, out.threshold.rx.mac_error, out.threshold.sce.rx_bc_frames, out.threshold.sce.rx_mc_frames, out.threshold.sce.rx_uc_frames, out.threshold.sce.rx_non_pppoe_frames, out.threshold.tx.tx_frames, out.threshold.tx.tx_bytes, out.threshold.tx.tx64, out.threshold.tx.tx65, out.threshold.tx.tx128, out.threshold.tx.tx256, out.threshold.tx.tx512, out.threshold.tx.tx1024, out.threshold.tx.tx1519, out.threshold.mac.rx_fcs_err, out.threshold.mac.algn_err, out.threshold.mac.rx_frag, out.threshold.mac.rx_buff_overflow_events, out.threshold.mac.tx_frag, out.threshold.mac.tx_jabber_frames, out.threshold.mac.tx_drop_events, out.threshold.mac.tx_buff_overflow_events, out.threshold.mac.tx_mac_err, out.threshold.mac.delay_exceeded, out.threshold.mac.exc_col, out.threshold.mac.late_col, out.threshold.mac.sgl_col, out.threshold.mac.mul_col, out.threshold.mac.def_trans, out.threshold.mac.carrier_sense_err, out.threshold.mac.sqe_test);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_tca_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct uni_port_id in;
	struct lan_cnt_val out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_tca_get" ONU_CRLF
		"Short Form: lantg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t uni_port_id" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint64_t rx_frames" ONU_CRLF
		"- uint64_t rx_bytes" ONU_CRLF
		"- uint64_t rx_undersized_frames" ONU_CRLF
		"- uint64_t rx_oversized_frames" ONU_CRLF
		"- uint64_t rx64" ONU_CRLF
		"- uint64_t rx65" ONU_CRLF
		"- uint64_t rx128" ONU_CRLF
		"- uint64_t rx256" ONU_CRLF
		"- uint64_t rx512" ONU_CRLF
		"- uint64_t rx1024" ONU_CRLF
		"- uint64_t rx1519" ONU_CRLF
		"- uint64_t buffer_overflow" ONU_CRLF
		"- uint64_t dma_write_error" ONU_CRLF
		"- uint64_t mac_error" ONU_CRLF
		"- uint64_t rx_bc_frames" ONU_CRLF
		"- uint64_t rx_mc_frames" ONU_CRLF
		"- uint64_t rx_uc_frames" ONU_CRLF
		"- uint64_t rx_non_pppoe_frames" ONU_CRLF
		"- uint64_t tx_frames" ONU_CRLF
		"- uint64_t tx_bytes" ONU_CRLF
		"- uint64_t tx64" ONU_CRLF
		"- uint64_t tx65" ONU_CRLF
		"- uint64_t tx128" ONU_CRLF
		"- uint64_t tx256" ONU_CRLF
		"- uint64_t tx512" ONU_CRLF
		"- uint64_t tx1024" ONU_CRLF
		"- uint64_t tx1519" ONU_CRLF
		"- uint64_t rx_fcs_err" ONU_CRLF
		"- uint64_t algn_err" ONU_CRLF
		"- uint64_t rx_frag" ONU_CRLF
		"- uint64_t rx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_frag" ONU_CRLF
		"- uint64_t tx_jabber_frames" ONU_CRLF
		"- uint64_t tx_drop_events" ONU_CRLF
		"- uint64_t tx_buff_overflow_events" ONU_CRLF
		"- uint64_t tx_mac_err" ONU_CRLF
		"- uint64_t delay_exceeded" ONU_CRLF
		"- uint64_t exc_col" ONU_CRLF
		"- uint64_t late_col" ONU_CRLF
		"- uint64_t sgl_col" ONU_CRLF
		"- uint64_t mul_col" ONU_CRLF
		"- uint64_t def_trans" ONU_CRLF
		"- uint64_t carrier_sense_err" ONU_CRLF
		"- uint64_t sqe_test" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.uni_port_id);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_tca_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d rx_frames=%llu rx_bytes=%llu rx_undersized_frames=%llu rx_oversized_frames=%llu rx64=%llu rx65=%llu rx128=%llu rx256=%llu rx512=%llu rx1024=%llu rx1519=%llu buffer_overflow=%llu dma_write_error=%llu mac_error=%llu rx_bc_frames=%llu rx_mc_frames=%llu rx_uc_frames=%llu rx_non_pppoe_frames=%llu tx_frames=%llu tx_bytes=%llu tx64=%llu tx65=%llu tx128=%llu tx256=%llu tx512=%llu tx1024=%llu tx1519=%llu rx_fcs_err=%llu algn_err=%llu rx_frag=%llu rx_buff_overflow_events=%llu tx_frag=%llu tx_jabber_frames=%llu tx_drop_events=%llu tx_buff_overflow_events=%llu tx_mac_err=%llu delay_exceeded=%llu exc_col=%llu late_col=%llu sgl_col=%llu mul_col=%llu def_trans=%llu carrier_sense_err=%llu sqe_test=%llu " ONU_CRLF, (int)fct_ret, out.rx.rx_frames, out.rx.rx_bytes, out.rx.rx_undersized_frames, out.rx.rx_oversized_frames, out.rx.rx64, out.rx.rx65, out.rx.rx128, out.rx.rx256, out.rx.rx512, out.rx.rx1024, out.rx.rx1519, out.rx.buffer_overflow, out.rx.dma_write_error, out.rx.mac_error, out.sce.rx_bc_frames, out.sce.rx_mc_frames, out.sce.rx_uc_frames, out.sce.rx_non_pppoe_frames, out.tx.tx_frames, out.tx.tx_bytes, out.tx.tx64, out.tx.tx65, out.tx.tx128, out.tx.tx256, out.tx.tx512, out.tx.tx1024, out.tx.tx1519, out.mac.rx_fcs_err, out.mac.algn_err, out.mac.rx_frag, out.mac.rx_buff_overflow_events, out.mac.tx_frag, out.mac.tx_jabber_frames, out.mac.tx_drop_events, out.mac.tx_buff_overflow_events, out.mac.tx_mac_err, out.mac.delay_exceeded, out.mac.exc_col, out.mac.late_col, out.mac.sgl_col, out.mac.mul_col, out.mac.def_trans, out.mac.carrier_sense_err, out.mac.sqe_test);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_wol_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct wol_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: wol_cfg_set" ONU_CRLF
		"Short Form: wolcs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint8_t wol_addr[6]" ONU_CRLF
		"- uint8_t wol_password[6]" ONU_CRLF
		"- uint32_t wol_password_en" ONU_CRLF
		"- uint32_t wol_interrupt_en" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %bu[6] %bu[6] %u %u", &param.index, &param.wol_addr[0], &param.wol_password[0], &param.wol_password_en, &param.wol_interrupt_en);
	if (ret != 15) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = wol_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_wol_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct wol_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: wol_cfg_get" ONU_CRLF
		"Short Form: wolcg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint8_t wol_addr[6]" ONU_CRLF
		"- uint8_t wol_password[6]" ONU_CRLF
		"- uint32_t wol_password_en" ONU_CRLF
		"- uint32_t wol_interrupt_en" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = wol_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u wol_addr=\"%u %u %u %u %u %u\" wol_password=\"%u %u %u %u %u %u\" wol_password_en=%u wol_interrupt_en=%u " ONU_CRLF, (int)fct_ret, out.index, out.wol_addr[0], out.wol_addr[1], out.wol_addr[2], out.wol_addr[3], out.wol_addr[4], out.wol_addr[5], out.wol_password[0], out.wol_password[1], out.wol_password[2], out.wol_password[3], out.wol_password[4], out.wol_password[5], out.wol_password_en, out.wol_interrupt_en);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_wol_status_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct wol_status out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: wol_status_get" ONU_CRLF
		"Short Form: wolsg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- uint32_t wol_sts" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = wol_status_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u wol_sts=%u " ONU_CRLF, (int)fct_ret, out.index, out.wol_sts);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mdio_data_read(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mdio in;
	struct mdio_read out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mdio_data_read" ONU_CRLF
		"Short Form: mdiodr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t addr_dev" ONU_CRLF
		"- uint8_t addr_reg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint16_t data" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %bu", &in.addr_dev, &in.addr_reg);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mdio_data_read(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d data=%hu " ONU_CRLF, (int)fct_ret, out.data);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mdio_data_write(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mdio_write param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mdio_data_write" ONU_CRLF
		"Short Form: mdiodw" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t addr_dev" ONU_CRLF
		"- uint8_t addr_reg" ONU_CRLF
		"- uint16_t data" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %bu %hu", &param.addr_dev, &param.addr_reg, &param.data);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mdio_data_write(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mdio_enable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mdio_en param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mdio_enable" ONU_CRLF
		"Short Form: mdioe" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum mdio_mode mode" ONU_CRLF
		"   MDIO_INTERNAL = 0" "\n"
		"   MDIO_EXTERNAL = 1" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.mode);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mdio_enable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mdio_disable(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mdio_dis param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mdio_disable" ONU_CRLF
		"Short Form: mdiod" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum mdio_mode mode" ONU_CRLF
		"   MDIO_INTERNAL = 0" "\n"
		"   MDIO_EXTERNAL = 1" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.mode);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mdio_disable(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mmd_data_read(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mmd in;
	struct mmd_read out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mmd_data_read" ONU_CRLF
		"Short Form: mmddr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t addr_dev" ONU_CRLF
		"- uint8_t mmd_sel" ONU_CRLF
		"- uint16_t mmd_addr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint16_t data" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %bu %hu", &in.addr_dev, &in.mmd_sel, &in.mmd_addr);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mmd_data_read(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d data=%hu " ONU_CRLF, (int)fct_ret, out.data);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_mmd_data_write(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct mmd_write param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: mmd_data_write" ONU_CRLF
		"Short Form: mmddw" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t addr_dev" ONU_CRLF
		"- uint8_t mmd_sel" ONU_CRLF
		"- uint16_t mmd_addr" ONU_CRLF
		"- uint16_t data" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %bu %hu %hu", &param.addr_dev, &param.mmd_sel, &param.mmd_addr, &param.data);
	if (ret != 4) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = mmd_data_write(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_capability_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_capability_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_capability_cfg_set" ONU_CRLF
		"Short Form: lanpccs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- bool full_duplex \n   false = 0\n   true = 1" ONU_CRLF
		"- bool half_duplex \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_10 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_100 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_1000 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool sym_pause \n   false = 0\n   true = 1" ONU_CRLF
		"- bool asym_pause \n   false = 0\n   true = 1" ONU_CRLF
		"- bool eee \n   false = 0\n   true = 1" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %bu %bu %bu %bu %bu %bu %bu %bu", &param.index, &param.full_duplex, &param.half_duplex, &param.mbit_10, &param.mbit_100, &param.mbit_1000, &param.sym_pause, &param.asym_pause, &param.eee);
	if (ret != 9) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_capability_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_lan_port_capability_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct lan_port_index in;
	struct lan_port_capability_cfg out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: lan_port_capability_cfg_get" ONU_CRLF
		"Short Form: lanpccg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t index" ONU_CRLF
		"- bool full_duplex \n   false = 0\n   true = 1" ONU_CRLF
		"- bool half_duplex \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_10 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_100 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool mbit_1000 \n   false = 0\n   true = 1" ONU_CRLF
		"- bool sym_pause \n   false = 0\n   true = 1" ONU_CRLF
		"- bool asym_pause \n   false = 0\n   true = 1" ONU_CRLF
		"- bool eee \n   false = 0\n   true = 1" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &in.index);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = lan_port_capability_cfg_get(p_dev, &in, &out);
	return sprintf(p_out, "errorcode=%d index=%u full_duplex=%u half_duplex=%u mbit_10=%u mbit_100=%u mbit_1000=%u sym_pause=%u asym_pause=%u eee=%u " ONU_CRLF, (int)fct_ret, out.index, out.full_duplex, out.half_duplex, out.mbit_10, out.mbit_100, out.mbit_1000, out.sym_pause, out.asym_pause, out.eee);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ploam_ds_insert(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct ploam_message param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ploam_ds_insert" ONU_CRLF
		"Short Form: ploamdi" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t data[12]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu[12]", &param.data[0]);
	if (ret != 12) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = ploam_ds_insert(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ploam_init(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ploam_init" ONU_CRLF
		"Short Form: ploami" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = ploam_init(p_dev);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ploam_state_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct ploam_state_data_get param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ploam_state_get" ONU_CRLF
		"Short Form: ploamsg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- enum ploam_state curr_state" ONU_CRLF
		"   PLOAM_STATE_O0 = 0" "\n"
		"   PLOAM_STATE_O1 = 1" "\n"
		"   PLOAM_STATE_O2 = 2" "\n"
		"   PLOAM_STATE_O3 = 3" "\n"
		"   PLOAM_STATE_O4 = 4" "\n"
		"   PLOAM_STATE_O5 = 5" "\n"
		"   PLOAM_STATE_O6 = 6" "\n"
		"   PLOAM_STATE_O7 = 7" "\n"
		"- enum ploam_state previous_state" ONU_CRLF
		"   PLOAM_STATE_O0 = 0" "\n"
		"   PLOAM_STATE_O1 = 1" "\n"
		"   PLOAM_STATE_O2 = 2" "\n"
		"   PLOAM_STATE_O3 = 3" "\n"
		"   PLOAM_STATE_O4 = 4" "\n"
		"   PLOAM_STATE_O5 = 5" "\n"
		"   PLOAM_STATE_O6 = 6" "\n"
		"   PLOAM_STATE_O7 = 7" "\n"
		"- uint32_t elapsed_msec" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = ploam_state_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d curr_state=%u previous_state=%u elapsed_msec=%u " ONU_CRLF, (int)fct_ret, param.curr_state, param.previous_state, param.elapsed_msec);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_ploam_state_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct ploam_state_data_set param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: ploam_state_set" ONU_CRLF
		"Short Form: ploamss" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- enum ploam_state state" ONU_CRLF
		"   PLOAM_STATE_O0 = 0" "\n"
		"   PLOAM_STATE_O1 = 1" "\n"
		"   PLOAM_STATE_O2 = 2" "\n"
		"   PLOAM_STATE_O3 = 3" "\n"
		"   PLOAM_STATE_O4 = 4" "\n"
		"   PLOAM_STATE_O5 = 5" "\n"
		"   PLOAM_STATE_O6 = 6" "\n"
		"   PLOAM_STATE_O7 = 7" "\n"
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.state);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = ploam_state_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_event_enable_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_event_mask param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_event_enable_set" ONU_CRLF
		"Short Form: onuees" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.val);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_event_enable_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_event_enable_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_event_mask param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_event_enable_get" ONU_CRLF
		"Short Form: onueeg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t val" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_event_enable_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d val=%u " ONU_CRLF, (int)fct_ret, param.val);
}

#if defined(INCLUDE_DEBUG_SUPPORT)
/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_debug_level_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_dbg_level param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_debug_level_set" ONU_CRLF
		"Short Form: onudls" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t level" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu", &param.level);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_debug_level_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_debug_level_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_dbg_level param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_debug_level_get" ONU_CRLF
		"Short Form: onudlg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t level" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_debug_level_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d level=%u " ONU_CRLF, (int)fct_ret, param.level);
}

#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_version_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_version_string param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: version_information_get" ONU_CRLF
		"Short Form: vig" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- char onu_version[80]" ONU_CRLF
		"- char fw_version[80]" ONU_CRLF
		"- char cop_version[80]" ONU_CRLF
		"- char sce_interface_version[80]" ONU_CRLF
		"- char chip_id[80]" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_version_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d onu_version=\"%s\" fw_version=\"%s\" cop_version=\"%s\" sce_interface_version=\"%s\" chip_id=\"%s\" " ONU_CRLF, (int)fct_ret, param.onu_version, param.fw_version, param.cop_version, param.sce_interface_version, param.chip_id);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_register_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_reg_addr_val param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_register_set" ONU_CRLF
		"Short Form: onurs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t form" ONU_CRLF
		"- ulong_t address" ONU_CRLF
		"- uint32_t value" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %lu %u", &param.form, &param.address, &param.value);
	if (ret != 3) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_register_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_register_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_reg_addr param_in;
	struct onu_reg_val param_out;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_register_get" ONU_CRLF
		"Short Form: onurg" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint8_t form" ONU_CRLF
		"- ulong_t address" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint8_t form" ONU_CRLF
		"- uint32_t value" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%bu %lu", &param_in.form, &param_in.address);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_register_get(p_dev, &param_in, &param_out);
	return sprintf(p_out, "errorcode=%d form=%u value=0x%x " ONU_CRLF, (int)fct_ret, param_out.form, param_out.value);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_test_mode_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_test_mode param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_test_mode_set" ONU_CRLF
		"Short Form: onutms" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- char mode[32]" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%s", &param.mode);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_test_mode_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_line_enable_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_enable param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_line_enable_set" ONU_CRLF
		"Short Form: onules" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.enable);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_line_enable_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_line_enable_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_enable param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_line_enable_get" ONU_CRLF
		"Short Form: onuleg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t enable" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_line_enable_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d enable=%u " ONU_CRLF, (int)fct_ret, param.enable);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_sync_time_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_sync_time param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_sync_time_set" ONU_CRLF
		"Short Form: onusts" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t interval_enable" ONU_CRLF
		"- uint32_t interval_supervision_ext" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u %u", &param.interval_enable, &param.interval_supervision_ext);
	if (ret != 2) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_sync_time_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_sync_time_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_sync_time param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_sync_time_get" ONU_CRLF
		"Short Form: onustg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t interval_enable" ONU_CRLF
		"- uint32_t interval_supervision_ext" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_sync_time_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d interval_enable=%u interval_supervision_ext=%u " ONU_CRLF, (int)fct_ret, param.interval_enable, param.interval_supervision_ext);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_counters_cfg_set(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_cnt_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_counters_cfg_set" ONU_CRLF
		"Short Form: onuccs" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t disable_update" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.disable_update);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_counters_cfg_set(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_counters_cfg_get(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_cnt_cfg param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_counters_cfg_get" ONU_CRLF
		"Short Form: onuccg" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		"- uint32_t disable_update" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	fct_ret = onu_counters_cfg_get(p_dev, &param);
	return sprintf(p_out, "errorcode=%d disable_update=%u " ONU_CRLF, (int)fct_ret, param.disable_update);
}

/** Handle command

   \param[in] p_dev     ONU device pointer
   \param[in] p_cmd     Input commands
   \param[in] p_out     Output FD
*/
static int cli_onu_counters_reset(
	struct onu_device *p_dev,
	const char *p_cmd,
	const uint32_t bufsize_max,
	char *p_out)
{
	int ret = 0;
	enum onu_errorcode fct_ret = (enum onu_errorcode) 0;
	struct onu_cnt_reset param;

#ifndef ONU_DEBUG_DISABLE
	static const char usage[] =
		"Long Form: onu_counters_reset" ONU_CRLF
		"Short Form: onucr" ONU_CRLF
		ONU_CRLF
		"Input Parameter" ONU_CRLF
		"- uint32_t curr" ONU_CRLF
		ONU_CRLF
		"Output Parameter" ONU_CRLF
		"- enum onu_errorcode errorcode" ONU_CRLF
		ONU_CRLF;
#else
#undef usage
#define usage ""
#endif

	if ((ret = onu_cli_check_help(p_cmd, usage, bufsize_max, p_out)) >= 0) {
		return ret;
	}
	ret = onu_cli_sscanf(p_cmd, "%u", &param.curr);
	if (ret != 1) {
		return onu_cli_check_help("-h", usage, bufsize_max, p_out);
	}
	fct_ret = onu_counters_reset(p_dev, &param);
	return sprintf(p_out, "errorcode=%d " ONU_CRLF, (int)fct_ret);
}

/** Register autogenerated commands */
void onu_cli_autogen_register(
	void)
{
onu_cli_command_add("gtci", "gtc_init", cli_gtc_init);
onu_cli_command_add("gtccs", "gtc_cfg_set", cli_gtc_cfg_set);
onu_cli_command_add("gtccg", "gtc_cfg_get", cli_gtc_cfg_get);
onu_cli_command_add("gtccts", "gtc_counter_threshold_set", cli_gtc_counter_threshold_set);
onu_cli_command_add("gtcctg", "gtc_counter_threshold_get", cli_gtc_counter_threshold_get);
onu_cli_command_add("gtctg", "gtc_tca_get", cli_gtc_tca_get);
onu_cli_command_add("gtcuhcg", "gtc_us_header_cfg_get", cli_gtc_us_header_cfg_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gtc_counter_get", cli_gtc_counter_get);
onu_cli_command_add("gtccr", "gtc_counter_reset", cli_gtc_counter_reset);
onu_cli_command_add("gtcsg", "gtc_status_get", cli_gtc_status_get);
onu_cli_command_add("gtcag", "gtc_alarm_get", cli_gtc_alarm_get);
onu_cli_command_add("gtcrg", "gtc_ranging_get", cli_gtc_ranging_get);
onu_cli_command_add("gtcdgcs", "gtc_dying_gasp_cfg_set", cli_gtc_dying_gasp_cfg_set);
onu_cli_command_add("gtcdgcg", "gtc_dying_gasp_cfg_get", cli_gtc_dying_gasp_cfg_get);
onu_cli_command_add("gtcnmcs", "gtc_no_message_cfg_set", cli_gtc_no_message_cfg_set);
onu_cli_command_add("gtcnmcg", "gtc_no_message_cfg_get", cli_gtc_no_message_cfg_get);
onu_cli_command_add("gtcpsms", "gtc_power_saving_mode_set", cli_gtc_power_saving_mode_set);
onu_cli_command_add("gtcpsmg", "gtc_power_saving_mode_get", cli_gtc_power_saving_mode_get);
onu_cli_command_add("gtcps", "gtc_ploam_send", cli_gtc_ploam_send);
onu_cli_command_add("gtcpr", "gtc_ploam_receive", cli_gtc_ploam_receive);
onu_cli_command_add("gtcsns", "gtc_serial_number_set", cli_gtc_serial_number_set);
onu_cli_command_add("gtcsng", "gtc_serial_number_get", cli_gtc_serial_number_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gtc_password_set", cli_gtc_password_set);
onu_cli_command_add("gtcpg", "gtc_password_get", cli_gtc_password_get);
onu_cli_command_add("gtcfas", "gtc_forced_alloc_set", cli_gtc_forced_alloc_set);
onu_cli_command_add("gtcfag", "gtc_forced_alloc_get", cli_gtc_forced_alloc_get);
onu_cli_command_add("gtcbcs", "gtc_bwmt_cfg_set", cli_gtc_bwmt_cfg_set);
onu_cli_command_add("gtcbcg", "gtc_bwmt_cfg_get", cli_gtc_bwmt_cfg_get);
onu_cli_command_add("gtcbn", "gtc_bwmt_next", cli_gtc_bwmt_next);
onu_cli_command_add("gtcbsg", "gtc_bwmt_status_get", cli_gtc_bwmt_status_get);
onu_cli_command_add("gtclctg", "gtc_last_change_time_get", cli_gtc_last_change_time_get);
onu_cli_command_add("gtcpig", "gtc_pon_id_get", cli_gtc_pon_id_get);
onu_cli_command_add("gpei", "gpe_init", cli_gpe_init);
onu_cli_command_add("gpedi", "gpe_debug_init", cli_gpe_debug_init);
onu_cli_command_add("gpellme", "gpe_low_level_modules_enable", cli_gpe_low_level_modules_enable);
onu_cli_command_add("gpecs", "gpe_cfg_set", cli_gpe_cfg_set);
onu_cli_command_add("gpecg", "gpe_cfg_get", cli_gpe_cfg_get);
onu_cli_command_add("gpesg", "gpe_status_get", cli_gpe_status_get);
onu_cli_command_add("gpegpa", "gpe_gem_port_add", cli_gpe_gem_port_add);
onu_cli_command_add("gpegpd", "gpe_gem_port_delete", cli_gpe_gem_port_delete);
onu_cli_command_add("gpegpg", "gpe_gem_port_get", cli_gpe_gem_port_get);
onu_cli_command_add("gpegps", "gpe_gem_port_set", cli_gpe_gem_port_set);
onu_cli_command_add("gpetc", "gpe_tcont_create", cli_gpe_tcont_create);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_tcont_set", cli_gpe_tcont_set);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_tcont_get", cli_gpe_tcont_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_tcont_delete", cli_gpe_tcont_delete);
onu_cli_command_add("gpeepc", "gpe_egress_port_create", cli_gpe_egress_port_create);
onu_cli_command_add("gpeepg", "gpe_egress_port_get", cli_gpe_egress_port_get);
onu_cli_command_add("gpepig", "gpe_port_index_get", cli_gpe_port_index_get);
onu_cli_command_add("gpeepd", "gpe_egress_port_delete", cli_gpe_egress_port_delete);
onu_cli_command_add("gpeepcs", "gpe_egress_port_cfg_set", cli_gpe_egress_port_cfg_set);
onu_cli_command_add("gpeepcg", "gpe_egress_port_cfg_get", cli_gpe_egress_port_cfg_get);
onu_cli_command_add("gpeepsg", "gpe_egress_port_status_get", cli_gpe_egress_port_status_get);
onu_cli_command_add("gpebcs", "gpe_backpressure_cfg_set", cli_gpe_backpressure_cfg_set);
onu_cli_command_add("gpebcg", "gpe_backpressure_cfg_get", cli_gpe_backpressure_cfg_get);
onu_cli_command_add("gpeiqcs", "gpe_ingress_queue_cfg_set", cli_gpe_ingress_queue_cfg_set);
onu_cli_command_add("gpeiqcg", "gpe_ingress_queue_cfg_get", cli_gpe_ingress_queue_cfg_get);
onu_cli_command_add("gpeiqsg", "gpe_ingress_queue_status_get", cli_gpe_ingress_queue_status_get);
onu_cli_command_add("gpeeqc", "gpe_egress_queue_create", cli_gpe_egress_queue_create);
onu_cli_command_add("gpeeqd", "gpe_egress_queue_delete", cli_gpe_egress_queue_delete);
onu_cli_command_add("gpeeqg", "gpe_egress_queue_get", cli_gpe_egress_queue_get);
onu_cli_command_add("gpeeqcs", "gpe_egress_queue_cfg_set", cli_gpe_egress_queue_cfg_set);
onu_cli_command_add("gpeeqcg", "gpe_egress_queue_cfg_get", cli_gpe_egress_queue_cfg_get);
onu_cli_command_add("gpeeqsg", "gpe_egress_queue_status_get", cli_gpe_egress_queue_status_get);
onu_cli_command_add("gpeeqpg", "gpe_egress_queue_path_get", cli_gpe_egress_queue_path_get);
onu_cli_command_add("gpesc", "gpe_scheduler_create", cli_gpe_scheduler_create);
onu_cli_command_add("gpesd", "gpe_scheduler_delete", cli_gpe_scheduler_delete);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_scheduler_get", cli_gpe_scheduler_get);
onu_cli_command_add("gpescs", "gpe_scheduler_cfg_set", cli_gpe_scheduler_cfg_set);
onu_cli_command_add("gpescg", "gpe_scheduler_cfg_get", cli_gpe_scheduler_cfg_get);
onu_cli_command_add("gpessg", "gpe_scheduler_status_get", cli_gpe_scheduler_status_get);
onu_cli_command_add("gpetbsc", "gpe_token_bucket_shaper_create", cli_gpe_token_bucket_shaper_create);
onu_cli_command_add("gpetbsd", "gpe_token_bucket_shaper_delete", cli_gpe_token_bucket_shaper_delete);
onu_cli_command_add("gpetbsg", "gpe_token_bucket_shaper_get", cli_gpe_token_bucket_shaper_get);
onu_cli_command_add("gpetbscs", "gpe_token_bucket_shaper_cfg_set", cli_gpe_token_bucket_shaper_cfg_set);
onu_cli_command_add("gpetbscg", "gpe_token_bucket_shaper_cfg_get", cli_gpe_token_bucket_shaper_cfg_get);
onu_cli_command_add("gpetbssg", "gpe_token_bucket_shaper_status_get", cli_gpe_token_bucket_shaper_status_get);
onu_cli_command_add("gpemc", "gpe_meter_create", cli_gpe_meter_create);
onu_cli_command_add("gpemd", "gpe_meter_delete", cli_gpe_meter_delete);
onu_cli_command_add("gpemcs", "gpe_meter_cfg_set", cli_gpe_meter_cfg_set);
onu_cli_command_add("gpemcg", "gpe_meter_cfg_get", cli_gpe_meter_cfg_get);
onu_cli_command_add("gpemsg", "gpe_meter_status_get", cli_gpe_meter_status_get);
onu_cli_command_add("gpesbcs", "gpe_shared_buffer_cfg_set", cli_gpe_shared_buffer_cfg_set);
onu_cli_command_add("gpesbcg", "gpe_shared_buffer_cfg_get", cli_gpe_shared_buffer_cfg_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_bridge_counter_get", cli_gpe_bridge_counter_get);
onu_cli_command_add("gpebpcg", "gpe_bridge_port_counter_get", cli_gpe_bridge_port_counter_get);
onu_cli_command_add("gpebcts", "gpe_bridge_counter_threshold_set", cli_gpe_bridge_counter_threshold_set);
onu_cli_command_add("gpebpcts", "gpe_bridge_port_counter_threshold_set", cli_gpe_bridge_port_counter_threshold_set);
onu_cli_command_add("gpebctg", "gpe_bridge_counter_threshold_get", cli_gpe_bridge_counter_threshold_get);
onu_cli_command_add("gpebpctg", "gpe_bridge_port_counter_threshold_get", cli_gpe_bridge_port_counter_threshold_get);
onu_cli_command_add("gpebtg", "gpe_bridge_tca_get", cli_gpe_bridge_tca_get);
onu_cli_command_add("gpebptg", "gpe_bridge_port_tca_get", cli_gpe_bridge_port_tca_get);
onu_cli_command_add("gpebcr", "gpe_bridge_counter_reset", cli_gpe_bridge_counter_reset);
onu_cli_command_add("gpebpcr", "gpe_bridge_port_counter_reset", cli_gpe_bridge_port_counter_reset);
onu_cli_command_add("gpepcs", "gpe_parser_cfg_set", cli_gpe_parser_cfg_set);
onu_cli_command_add("gpepcg", "gpe_parser_cfg_get", cli_gpe_parser_cfg_get);
onu_cli_command_add("gpeefcs", "gpe_ethertype_filter_cfg_set", cli_gpe_ethertype_filter_cfg_set);
onu_cli_command_add("gpeefcg", "gpe_ethertype_filter_cfg_get", cli_gpe_ethertype_filter_cfg_get);
onu_cli_command_add("gpeos", "gpe_omci_send", cli_gpe_omci_send);
onu_cli_command_add("gpeti", "gpe_tod_init", cli_gpe_tod_init);
onu_cli_command_add("gpetss", "gpe_tod_sync_set", cli_gpe_tod_sync_set);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_tod_get", cli_gpe_tod_get);
onu_cli_command_add("gpetsg", "gpe_tod_sync_get", cli_gpe_tod_sync_get);
onu_cli_command_add("gpeigcs", "gpe_iqm_global_cfg_set", cli_gpe_iqm_global_cfg_set);
onu_cli_command_add("gpeigcg", "gpe_iqm_global_cfg_get", cli_gpe_iqm_global_cfg_get);
onu_cli_command_add("gpeigsg", "gpe_iqm_global_status_get", cli_gpe_iqm_global_status_get);
onu_cli_command_add("gpetgcg", "gpe_tmu_global_cfg_get", cli_gpe_tmu_global_cfg_get);
onu_cli_command_add("gpetgsg", "gpe_tmu_global_status_get", cli_gpe_tmu_global_status_get);
onu_cli_command_add("gpetcg", "gpe_tmu_counter_get", cli_gpe_tmu_counter_get);
onu_cli_command_add("gpetcr", "gpe_tmu_counter_reset", cli_gpe_tmu_counter_reset);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_sce_counter_get", cli_gpe_sce_counter_get);
onu_cli_command_add("gpescr", "gpe_sce_counter_reset", cli_gpe_sce_counter_reset);
onu_cli_command_add("gpegcg", "gpe_gem_counter_get", cli_gpe_gem_counter_get);
onu_cli_command_add("gpegcts", "gpe_gem_counter_threshold_set", cli_gpe_gem_counter_threshold_set);
onu_cli_command_add("gpegctg", "gpe_gem_counter_threshold_get", cli_gpe_gem_counter_threshold_get);
onu_cli_command_add("gpegtg", "gpe_gem_tca_get", cli_gpe_gem_tca_get);
onu_cli_command_add("gpegcr", "gpe_gem_counter_reset", cli_gpe_gem_counter_reset);
#if defined(INCLUDE_SCE_DEBUG)
onu_cli_command_add("scebs", "sce_break_set", cli_sce_break_set);
onu_cli_command_add("scebae", "sce_break_autocheck_enable", cli_sce_break_autocheck_enable);
onu_cli_command_add("scebg", "sce_break_get", cli_sce_break_get);
onu_cli_command_add("scebr", "sce_break_remove", cli_sce_break_remove);
onu_cli_command_add("sceb", "sce_break", cli_sce_break);
onu_cli_command_add("scess", "sce_single_step", cli_sce_single_step);
onu_cli_command_add("scer", "sce_run", cli_sce_run);
onu_cli_command_add("scerv", "sce_restart_vm", cli_sce_restart_vm);
onu_cli_command_add("scerm", "sce_run_mask", cli_sce_run_mask);
onu_cli_command_add("scebm", "sce_break_mask", cli_sce_break_mask);
onu_cli_command_add("scesg", "sce_status_get", cli_sce_status_get);
onu_cli_command_add("scers", "sce_reg_set", cli_sce_reg_set);
onu_cli_command_add("scerg", "sce_reg_get", cli_sce_reg_get);
onu_cli_command_add("scems", "sce_mem_set", cli_sce_mem_set);
onu_cli_command_add("scemg", "sce_mem_get", cli_sce_mem_get);
#endif /* defined(INCLUDE_SCE_DEBUG) */
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_sce_download", cli_gpe_sce_download);
onu_cli_command_add("gpesvg", "gpe_sce_version_get", cli_gpe_sce_version_get);
onu_cli_command_add("gpefepc", "gpe_flat_egress_path_create", cli_gpe_flat_egress_path_create);
onu_cli_command_add("gpefc", "gpe_fsqm_check", cli_gpe_fsqm_check);
onu_cli_command_add("gpecd", "gpe_cop_download", cli_gpe_cop_download);
onu_cli_command_add("gpelecs", "gpe_lan_exception_cfg_set", cli_gpe_lan_exception_cfg_set);
onu_cli_command_add("gpelecg", "gpe_lan_exception_cfg_get", cli_gpe_lan_exception_cfg_get);
onu_cli_command_add("gpeaecs", "gpe_ani_exception_cfg_set", cli_gpe_ani_exception_cfg_set);
onu_cli_command_add("gpeaecg", "gpe_ani_exception_cfg_get", cli_gpe_ani_exception_cfg_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_exception_queue_cfg_set", cli_gpe_exception_queue_cfg_set);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_exception_queue_cfg_get", cli_gpe_exception_queue_cfg_get);
onu_cli_command_add("gpelpas", "gpe_lan_port_acl_set", cli_gpe_lan_port_acl_set);
onu_cli_command_add("gpelpag", "gpe_lan_port_acl_get", cli_gpe_lan_port_acl_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_capability_get", cli_gpe_capability_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_exception_profile_cfg_set", cli_gpe_exception_profile_cfg_set);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_exception_profile_cfg_get", cli_gpe_exception_profile_cfg_get);
onu_cli_command_add("gpeepe", "gpe_egress_port_enable", cli_gpe_egress_port_enable);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_egress_port_disable", cli_gpe_egress_port_disable);
onu_cli_command_add("gpesfmmpa", "gpe_short_fwd_mac_mc_port_add", cli_gpe_short_fwd_mac_mc_port_add);
onu_cli_command_add("gpesfmmpd", "gpe_short_fwd_mac_mc_port_delete", cli_gpe_short_fwd_mac_mc_port_delete);
onu_cli_command_add("gpesfmmpm", "gpe_short_fwd_mac_mc_port_modify", cli_gpe_short_fwd_mac_mc_port_modify);
onu_cli_command_add("gpesfi4mpa", "gpe_short_fwd_ipv4_mc_port_add", cli_gpe_short_fwd_ipv4_mc_port_add);
onu_cli_command_add("gpesfi4mpd", "gpe_short_fwd_ipv4_mc_port_delete", cli_gpe_short_fwd_ipv4_mc_port_delete);
onu_cli_command_add("gpesfi4mpm", "gpe_short_fwd_ipv4_mc_port_modify", cli_gpe_short_fwd_ipv4_mc_port_modify);
onu_cli_command_add("gpeats", "gpe_aging_time_set", cli_gpe_aging_time_set);
onu_cli_command_add("gpeatg", "gpe_aging_time_get", cli_gpe_aging_time_get);
onu_cli_command_add("gpeatsd", "gpe_aging_time_set_debug", cli_gpe_aging_time_set_debug);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_sce_constants_get", cli_gpe_sce_constants_get);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_sce_constants_set", cli_gpe_sce_constants_set);
onu_cli_command_add("gpesmg", "gpe_sce_mac_get", cli_gpe_sce_mac_get);
onu_cli_command_add("gpesms", "gpe_sce_mac_set", cli_gpe_sce_mac_set);
onu_cli_command_add("gpevfa", "gpe_vlan_fid_add", cli_gpe_vlan_fid_add);
onu_cli_command_add("gpevfg", "gpe_vlan_fid_get", cli_gpe_vlan_fid_get);
onu_cli_command_add("gpevfd", "gpe_vlan_fid_delete", cli_gpe_vlan_fid_delete);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_bridge_port_cfg_get", cli_gpe_bridge_port_cfg_get);
onu_cli_command_add("gpecds", "gpe_cop_debug_set", cli_gpe_cop_debug_set);
onu_cli_command_add(CLI_EMPTY_CMD, "gpe_cop_debug_server", cli_gpe_cop_debug_server);
onu_cli_command_add("gpeates", "gpe_acl_table_entry_set", cli_gpe_acl_table_entry_set);
onu_cli_command_add("gpeateg", "gpe_acl_table_entry_get", cli_gpe_acl_table_entry_get);
onu_cli_command_add("gpeated", "gpe_acl_table_entry_delete", cli_gpe_acl_table_entry_delete);
onu_cli_command_add("langfd", "lan_gphy_firmware_download", cli_lan_gphy_firmware_download);
onu_cli_command_add("lani", "lan_init", cli_lan_init);
onu_cli_command_add("lancs", "lan_cfg_set", cli_lan_cfg_set);
onu_cli_command_add("lancg", "lan_cfg_get", cli_lan_cfg_get);
onu_cli_command_add("lanpcs", "lan_port_cfg_set", cli_lan_port_cfg_set);
onu_cli_command_add("lanpcg", "lan_port_cfg_get", cli_lan_port_cfg_get);
onu_cli_command_add("lanpe", "lan_port_enable", cli_lan_port_enable);
onu_cli_command_add("lanpd", "lan_port_disable", cli_lan_port_disable);
onu_cli_command_add("lanlcs", "lan_loop_cfg_set", cli_lan_loop_cfg_set);
onu_cli_command_add("lanlcg", "lan_loop_cfg_get", cli_lan_loop_cfg_get);
onu_cli_command_add("lanpsg", "lan_port_status_get", cli_lan_port_status_get);
onu_cli_command_add(CLI_EMPTY_CMD, "lan_counter_get", cli_lan_counter_get);
onu_cli_command_add("lancr", "lan_counter_reset", cli_lan_counter_reset);
onu_cli_command_add("lancts", "lan_counter_threshold_set", cli_lan_counter_threshold_set);
onu_cli_command_add("lanctg", "lan_counter_threshold_get", cli_lan_counter_threshold_get);
onu_cli_command_add("lantg", "lan_tca_get", cli_lan_tca_get);
onu_cli_command_add("wolcs", "wol_cfg_set", cli_wol_cfg_set);
onu_cli_command_add("wolcg", "wol_cfg_get", cli_wol_cfg_get);
onu_cli_command_add("wolsg", "wol_status_get", cli_wol_status_get);
onu_cli_command_add("mdiodr", "mdio_data_read", cli_mdio_data_read);
onu_cli_command_add("mdiodw", "mdio_data_write", cli_mdio_data_write);
onu_cli_command_add("mdioe", "mdio_enable", cli_mdio_enable);
onu_cli_command_add("mdiod", "mdio_disable", cli_mdio_disable);
onu_cli_command_add("mmddr", "mmd_data_read", cli_mmd_data_read);
onu_cli_command_add("mmddw", "mmd_data_write", cli_mmd_data_write);
onu_cli_command_add("lanpccs", "lan_port_capability_cfg_set", cli_lan_port_capability_cfg_set);
onu_cli_command_add("lanpccg", "lan_port_capability_cfg_get", cli_lan_port_capability_cfg_get);
onu_cli_command_add("ploamdi", "ploam_ds_insert", cli_ploam_ds_insert);
onu_cli_command_add("ploami", "ploam_init", cli_ploam_init);
onu_cli_command_add("ploamsg", "ploam_state_get", cli_ploam_state_get);
onu_cli_command_add("ploamss", "ploam_state_set", cli_ploam_state_set);
onu_cli_command_add("onuees", "onu_event_enable_set", cli_onu_event_enable_set);
onu_cli_command_add("onueeg", "onu_event_enable_get", cli_onu_event_enable_get);
#if defined(INCLUDE_DEBUG_SUPPORT)
onu_cli_command_add("onudls", "onu_debug_level_set", cli_onu_debug_level_set);
onu_cli_command_add("onudlg", "onu_debug_level_get", cli_onu_debug_level_get);
#endif /* defined(INCLUDE_DEBUG_SUPPORT) */
onu_cli_command_add("vig", "version_information_get", cli_onu_version_get);
onu_cli_command_add("onurs", "onu_register_set", cli_onu_register_set);
onu_cli_command_add("onurg", "onu_register_get", cli_onu_register_get);
onu_cli_command_add("onutms", "onu_test_mode_set", cli_onu_test_mode_set);
onu_cli_command_add("onules", "onu_line_enable_set", cli_onu_line_enable_set);
onu_cli_command_add("onuleg", "onu_line_enable_get", cli_onu_line_enable_get);
onu_cli_command_add("onusts", "onu_sync_time_set", cli_onu_sync_time_set);
onu_cli_command_add("onustg", "onu_sync_time_get", cli_onu_sync_time_get);
onu_cli_command_add("onuccs", "onu_counters_cfg_set", cli_onu_counters_cfg_set);
onu_cli_command_add("onuccg", "onu_counters_cfg_get", cli_onu_counters_cfg_get);
onu_cli_command_add("onucr", "onu_counters_reset", cli_onu_counters_reset);
}

/*! @} */

#endif
